<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.0                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 529     Patch: 11                                                 |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Articles
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function AdminArticleCategories
 * A function to manage article categories
 * @author Philipp Louis Esselbach
 */
function AdminArticleCategories( $opts )
{
	global $database, $security, $system, $preferences, $html, $words_articles;
	$options = explode( "-", $opts );
	$options[ 0 ] = ( isset( $options[ 0 ] ) ) ? $security -> checkvar( $options[ 0 ] ) : "" ;
	$options[ 1 ] = ( isset( $options[ 1 ] ) ) ? $security -> checknum( $options[ 1 ] ) : "" ;
	$options[ 2 ] = ( isset( $options[ 2 ] ) ) ? $security -> checkvar( $options[ 2 ] ) : "" ;
	
	if( $options[ 0 ] )
	{
		if( ( $system -> adminhashget() != $options[ 2 ] ) and( $preferences[ 'website_subsessions_admin' ] ) )
		{
			$html -> login( $words_articles[ 'ERROR' ], $words_articles[ 'INVALID_SESSION' ], "index.php" );
			exit;
		}
	}

	if( $options[ 0 ] == "deletecat" )
	{
		$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_articlescats WHERE articlecat_id='" . $options[ 1 ] . "'" );
		$html -> login( $words_articles[ 'EDIT_CATEGORY' ], $words_articles[ 'CATEGORY_REMOVED' ], "index.php?action=articlecategories" );
	}

	if( $options[ 0 ] == "editcat" )
	{
		$query = $database -> dbquery( "SELECT articlecat_id, articlecat_website, articlecat_name, articlecat_seo, articlecat_description, articlecat_keywords, articlecat_parentcat FROM " . DB_PREFIX . "esselbach_ct_articlescats WHERE articlecat_id = '" . $options[ 1 ] . "'" );
		list( $articlecat_id, $articlecat_website, $articlecat_name, $articlecat_seo, $articlecat_description, $articlecat_keywords, $articlecat_parentcat ) = $database -> dbrow( $query );
		$html -> makeheader( $words_articles[ 'EDIT_CATEGORY' ] );
		$html -> deleteinit( $words_articles[ 'ARE_YOU_SURE' ] );
		$html -> makesubheader();
		$html -> makegroupmenu( "articles" );
		$html -> makeformheader( $words_articles[ 'EDIT_CATEGORY' ], "edit", "editform", "post" );
		$websites = array();
		$query = $database -> dbquery( "SELECT preference_website, preference_value FROM " . DB_PREFIX . "esselbach_ct_preferences WHERE preference_key = 'WEBSITE_NAME'" );
		
		if( $database -> dbrows( $query ) )
		{
			echo "<strong>" . $words_articles[ 'WEBSITE' ] . ":</strong> <select size=\"1\" name=\"input_category_website\">";
			echo "<option value=\"0\">" . $words_articles[ 'ALL' ] . "</option>";
			
			while( list( $website_id, $website_name ) = $database -> dbrow( $query ) )
			{
				if( $website_id == $articlecat_website )
				{
					echo "<option selected=\"selected\" value=\"" . $website_id . "\">" . $website_name . "</option>";
				}
				else
				{
					echo "<option value=\"" . $website_id . "\">" . $website_name . "</option>";
				}
				
				$websites[ $website_id ] = $website_name;
			}
			
			echo "</select> ";
		}
		
		echo "<strong>" . $words_articles[ 'PARENT_CATEGORY' ] . ":</strong><select size=\"1\" name=\"input_category_parent\">";
		echo "<option value=\"0\">" . $words_articles[ 'NONE' ] . "</option>";
		$query = $database -> dbquery( "SELECT articlecat_id, articlecat_website, articlecat_name, articlecat_parentid FROM " . DB_PREFIX . "esselbach_ct_articlescats WHERE NOT(articlecat_id = '" . $articlecat_id . "') ORDER BY articlecat_position, articlecat_parentcat, articlecat_id" );
		
		while( list( $articlecat_pid, $articlecat_parentwebsite, $articlecat_parentname, $articlecat_parentid ) = $database -> dbrow( $query ) )
		{
			
			if( $articlecat_parentid > 1 )
			{
				$articlecat_parentname = str_repeat( "-", $articlecat_parentid ) . " " . $articlecat_parentname;
			}
			
			
			if( isset( $websites[ $articlecat_website ] ) )
			{
				$articlecat_parentwebsite = " (" . $websites[ $articlecat_parentwebsite ] . ")";
			}
			else
			{
				$articlecat_parentwebsite = "";
			}
			
			
			if( $articlecat_parentcat == $articlecat_pid )
			{
				echo "<option selected=\"selected\" value=\"" . $articlecat_pid . "\">" . $articlecat_parentname . $articlecat_parentwebsite . "</option>";
			}
			else
			{
				echo "<option value=\"" . $articlecat_pid . "\">" . $articlecat_parentname . $articlecat_parentwebsite . "</option>";
			}
		}
		
		echo "</select><br />";
		$html -> uppertext( $words_articles[ 'CATEGORY_NAME' ], "input_category_name", $articlecat_name );
		$html -> uppertext( $words_articles[ 'CATEGORY_DESCRIPTION' ], "input_category_description", $articlecat_description );
		$html -> uppertext( $words_articles[ 'CATEGORY_KEYWORDS' ], "input_category_keywords", $articlecat_keywords );
		$html -> uppertext( $words_articles[ 'CATEGORY_SEO_URL' ], "input_category_seo", $articlecat_seo );
		echo "<input type=\"hidden\" name=\"input_security_hash\" value=\"" . $options[ 2 ] . "\" /><input type=\"hidden\" name=\"aform\" value=\"doeditarticlecategory\" /><input type=\"hidden\" name=\"input_category_id\" value=\"" . $articlecat_id . "\" /><input type=\"submit\" value=\"" . $words_articles[ 'SUBMIT' ] . "\" />";
		$query = $database -> dbquery( "SELECT articlecat_id, articlecat_name FROM " . DB_PREFIX . "esselbach_ct_articlescats WHERE articlecat_parentcat = '" . $options[ 1 ] . "' ORDER BY articlecat_position" );
		
		if( $database -> dbrows( $query ) )
		{
			$html -> tableheader( $words_articles[ 'ID' ], $words_articles[ 'SUBCATEGORY' ] );
			
			while( list( $articlecat_id, $articlecat_name ) = $database -> dbrow( $query ) )
			{
				$html -> tablemiddle( $articlecat_id, $articlecat_name, "articlecategories&amp;opts=editcat-" . $articlecat_id . "-" . $options[ 2 ], "articlecategories&amp;opts=deletecat-" . $articlecat_id . "-" . $options[ 2 ] );
			}
			
			$html -> maketablefooter();
		}
		
		$html -> makeformfooter();
	}

	if( $options[ 0 ] == "upcat" )
	{
		$query = $database -> dbquery( "SELECT articlecat_position FROM " . DB_PREFIX . "esselbach_ct_articlescats WHERE articlecat_id = '" . $options[ 1 ] . "'" );
		list( $position ) = $database -> dbrow( $query );
		
		if( $position == 1 )
		{
			$html -> login( $words_articles[ 'EDIT_CATEGORY' ], $words_articles[ 'CAT_ALREADY_TOP' ], "index.php?action=articlecategories" );
		}
		else
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_articlescats SET articlecat_position = articlecat_position - 1 WHERE articlecat_id = '" . $options[ 1 ] . "'" );
			$html -> login( $words_articles[ 'EDIT_CATEGORY' ], $words_articles[ 'CAT_INCREASED_PRIORITY' ], "index.php?action=articlecategories" );
		}
	}

	if( $options[ 0 ] == "downcat" )
	{
		$query = $database -> dbquery( "SELECT COUNT(articlecat_id) FROM " . DB_PREFIX . "esselbach_ct_articlescats" );
		list( $end_position ) = $database -> dbrow( $query );
		$query = $database -> dbquery( "SELECT articlecat_position FROM " . DB_PREFIX . "esselbach_ct_articlescats WHERE articlecat_id = '" . $options[ 1 ] . "'" );
		list( $current_position ) = $database -> dbrow( $query );
		
		if( $current_position == $end_position )
		{
			$html -> login( $words_articles[ 'EDIT_CATEGORY' ], $words_articles[ 'CAT_ALREADY_LAST' ], "index.php?action=articlecategories" );
		}
		else
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_articlescats SET articlecat_position = articlecat_position + 1 WHERE articlecat_id = '" . $options[ 1 ] . "'" );
			$html -> login( $words_articles[ 'EDIT_CATEGORY' ], $words_articles[ 'CAT_DECREASED_PRIORITY' ], "index.php?action=articlecategories" );
		}
	}

	if( !$options[ 0 ] )
	{
		
		$security_hash = $system -> adminhashput();
		
		$html -> makeheader( $words_articles[ 'ARTICLES_CATEGORIES' ] );
		$html -> deleteinit( $words_articles[ 'ARE_YOU_SURE' ] );
		$html -> makesubheader();
		$html -> makegroupmenu( "articles" );
		$html -> makeformheader( $words_articles[ 'ARTICLES_CATEGORIES' ], "categories", "doordercategories", "post" );
		$html -> tableheader( $words_articles[ 'CATEGORY_SITEID' ], $words_articles[ 'CATEGORY' ] );
		$query = $database -> dbquery( "SELECT articlecat_id, articlecat_website, articlecat_name, articlecat_parentid, articlecat_position FROM " . DB_PREFIX . "esselbach_ct_articlescats ORDER BY articlecat_position, articlecat_parentcat, articlecat_id" );
		
		while( list( $articlecat_id, $articlecat_website, $articlecat_name, $articlecat_parentid, $articlecat_position ) = $database -> dbrow( $query ) )
		{
			
			if( $articlecat_parentid > 1 )
			{
				$articlecat_name = str_repeat( "-", $articlecat_parentid ) . " " . $articlecat_name;
			}
			
			$html -> tablemiddle( $articlecat_id . " / " . $articlecat_website, $articlecat_name . " <a href=\"index.php?action=articlecategories&amp;opts=upcat-" . $articlecat_id . "-" . $security_hash . "\"><img src=\"../images/up.gif\" alt=\"up\" /></a> <a href=\"index.php?action=articlecategories&amp;opts=downcat-" . $articlecat_id . "-" . $security_hash . "\"><img src=\"../images/down.gif\" alt=\"down\" /></a> (" . $words_articles[ 'PRIORITY' ] . ": <input name=\"input_priority[" . $articlecat_id . "]\" size=\"3\" value=\"" . $articlecat_position . "\" />)", "articlecategories&amp;opts=editcat-" . $articlecat_id . "-" . $security_hash, "articlecategories&amp;opts=deletecat-" . $articlecat_id . "-" . $security_hash );
		}
		
		$html -> table5col( "<input type=\"hidden\" name=\"input_security_hash\" value=\"" . $security_hash . "\" /><input type=\"hidden\" name=\"aform\" value=\"doupdatearticlecategories\" /><input type=\"submit\" value=\"" . $words_articles[ 'UPDATE_PRIORITY' ] . "\" /><input type=\"submit\" name=\"input_doalphabetically\" value=\"" . $words_articles[ 'ORDER_ALPHABETICALLY' ] . "\" /></form>" );
		
		$html -> maketablefooter();
		$html -> makeformsub( $words_articles[ 'ADD_A_NEW_CATEGORY' ] );
		$websites = array();
		$query = $database -> dbquery( "SELECT preference_website, preference_value FROM " . DB_PREFIX . "esselbach_ct_preferences WHERE preference_key = 'WEBSITE_NAME'" );
		
		if( $database -> dbrows( $query ) )
		{
			echo "<strong>" . $words_articles[ 'WEBSITE' ] . ":</strong> <select size=\"1\" name=\"input_category_website\">";
			echo "<option value=\"0\">" . $words_articles[ 'ALL' ] . "</option>";
			
			while( list( $website_id, $website_name ) = $database -> dbrow( $query ) )
			{
				echo "<option value=\"" . $website_id . "\">" . $website_name . "</option>";
				$websites[ $website_id ] = $website_name;
			}
			
			echo "</select><br />";
		}
		
		$html -> makeeoption( $words_articles[ 'CATEGORY_NAME' ], "input_category_name", "" );
		$html -> makeeoption( $words_articles[ 'CATEGORY_DESCRIPTION' ], "input_category_description", "" );
		$html -> makeeoption( $words_articles[ 'CATEGORY_KEYWORDS' ], "input_category_keywords", "" );
		$html -> makeeoption( $words_articles[ 'CATEGORY_SEO_URL' ], "input_category_seo", "" );
		echo "<strong>" . $words_articles[ 'PARENT_CATEGORY' ] . ":</strong><br /><select size=\"1\" name=\"input_category_parent\">";
		echo "<option value=\"0\">" . $words_articles[ 'NONE' ] . "</option>";
		$query = $database -> dbquery( "SELECT articlecat_id, articlecat_website, articlecat_name, articlecat_parentid FROM " . DB_PREFIX . "esselbach_ct_articlescats ORDER BY articlecat_position, articlecat_parentcat, articlecat_id" );
		
		while( list( $articlecat_id, $articlecat_website, $articlecat_name, $articlecat_parentid ) = $database -> dbrow( $query ) )
		{
			
			if( $articlecat_parentid > 1 )
			{
				$articlecat_name = str_repeat( "-", $articlecat_parentid ) . " " . $articlecat_name;
			}
			
			
			if( isset( $websites[ $articlecat_website ] ) )
			{
				$articlecat_website = " (" . $websites[ $articlecat_website ] . ")";
			}
			else
			{
				$articlecat_website = "";
			}
			
			echo "<option value=\"" . $articlecat_id . "\">" . $articlecat_name . $articlecat_website . "</option>";
		}
		
		echo "</select>";
		echo "<br /><input type=\"hidden\" name=\"input_security_hash\" value=\"" . $security_hash . "\" /><input type=\"hidden\" name=\"aform\" value=\"doaddarticlecategory\" /><input type=\"submit\" value=\"" . $words_articles[ 'SUBMIT' ] . "\" />";
		$html -> makeformfooter();
	}
}
?>