<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.0                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 529     Patch: 11                                                 |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Contacts
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function AdminContactCategories
 * A function to manage contact categories
 * @author Philipp Louis Esselbach
 */
function AdminContactCategories( $opts )
{
	global $database, $security, $preferences, $system, $html, $words_contacts;
	$options = explode( "-", $opts );
	$options[ 0 ] = ( isset( $options[ 0 ] ) ) ? $security -> checkvar( $options[ 0 ] ) : "" ;
	$options[ 1 ] = ( isset( $options[ 1 ] ) ) ? $security -> checknum( $options[ 1 ] ) : "" ;
	$options[ 2 ] = ( isset( $options[ 2 ] ) ) ? $security -> checkvar( $options[ 2 ] ) : "" ;
	
	if( $options[ 0 ] )
	{
		if( ( $system -> adminhashget() != $options[ 2 ] ) and( $preferences[ 'website_subsessions_admin' ] ) )
		{
			$html -> login( $words_contacts[ 'ERROR' ], $words_contacts[ 'INVALID_SESSION' ], "index.php" );
			exit;
		}
	}

	if( $options[ 0 ] == "deletecat" )
	{
		$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_contactscats WHERE contactcat_id='" . $options[ 1 ] . "'" );
		$html -> login( $words_contacts[ 'EDIT_CATEGORY' ], $words_contacts[ 'CATEGORY_REMOVED' ], "index.php?action=contactcategories" );
	}

	if( $options[ 0 ] == "editcat" )
	{
		$query = $database -> dbquery( "SELECT contactcat_id, contactcat_website, contactcat_name FROM " . DB_PREFIX . "esselbach_ct_contactscats WHERE contactcat_id = '" . $options[ 1 ] . "'" );
		list( $contactcat_id, $contactcat_website, $contactcat_name ) = $database -> dbrow( $query );
		$html -> makeheader( $words_contacts[ 'EDIT_CATEGORY' ] );
		$html -> deleteinit( $words_contacts[ 'ARE_YOU_SURE' ] );
		$html -> makesubheader();
		$html -> makegroupmenu( "contacts" );
		$html -> makeformheader( $words_contacts[ 'EDIT_CATEGORY' ], "edit", "editform", "post" );
		$query = $database -> dbquery( "SELECT preference_website, preference_value FROM " . DB_PREFIX . "esselbach_ct_preferences WHERE preference_key = 'WEBSITE_NAME'" );
		
		if( $database -> dbrows( $query ) )
		{
			echo "<strong>" . $words_contacts[ 'WEBSITE' ] . ":</strong> <select size=\"1\" name=\"input_category_website\">";
			echo "<option value=\"0\">" . $words_contacts[ 'ALL' ] . "</option>";
			
			while( list( $website_id, $website_name ) = $database -> dbrow( $query ) )
			{
				if( $website_id == $contactcat_website )
				{
					echo "<option selected=\"selected\" value=\"" . $website_id . "\">" . $website_name . "</option>";
				}
				else
				{
					echo "<option value=\"" . $website_id . "\">" . $website_name . "</option>";
				}
			}
			
			echo "</select><br />";
		}
		
		$html -> uppertext( $words_contacts[ 'CATEGORY_NAME' ], "input_category_name", $contactcat_name );
		echo "<input type=\"hidden\" name=\"input_security_hash\" value=\"" . $options[ 2 ] . "\" /><input type=\"hidden\" name=\"aform\" value=\"doeditcontactcategory\" /><input type=\"hidden\" name=\"input_category_id\" value=\"" . $contactcat_id . "\" /><input type=\"submit\" value=\"" . $words_contacts[ 'SUBMIT' ] . "\" />";
		$query = $database -> dbquery( "SELECT contactcat_id, contactcat_name FROM " . DB_PREFIX . "esselbach_ct_contactscats WHERE contactcat_parentcat = '" . $options[ 1 ] . "' ORDER BY contactcat_position" );
		
		if( $database -> dbrows( $query ) )
		{
			$html -> tableheader( $words_contacts[ 'ID' ], $words_contacts[ 'SUBCATEGORY' ] );
			
			while( list( $contactcat_id, $contactcat_name ) = $database -> dbrow( $query ) )
			{
				$html -> tablemiddle( $contactcat_id, $contactcat_name, "contactcategories&amp;opts=editcat-" . $contactcat_id . "-" . $options[ 2 ], "contactcategories&amp;opts=deletecat-" . $contactcat_id . "-" . $options[ 2 ] );
			}
			
			$html -> maketablefooter();
		}
		
		$html -> makeformfooter();
	}

	if( $options[ 0 ] == "upcat" )
	{
		$query = $database -> dbquery( "SELECT contactcat_position FROM " . DB_PREFIX . "esselbach_ct_contactscats WHERE contactcat_id = '" . $options[ 1 ] . "'" );
		list( $position ) = $database -> dbrow( $query );
		
		if( $position == 1 )
		{
			$html -> login( $words_contacts[ 'EDIT_CATEGORY' ], $words_contacts[ 'CAT_ALREADY_TOP' ], "index.php?action=contactcategories" );
		}
		else
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_contactscats SET contactcat_position = contactcat_position - 1 WHERE contactcat_id = '" . $options[ 1 ] . "'" );
			$html -> login( $words_contacts[ 'EDIT_CATEGORY' ], $words_contacts[ 'CAT_INCREASED_PRIORITY' ], "index.php?action=contactcategories" );
		}
	}

	if( $options[ 0 ] == "downcat" )
	{
		$query = $database -> dbquery( "SELECT COUNT(contactcat_id) FROM " . DB_PREFIX . "esselbach_ct_contactscats" );
		list( $end_position ) = $database -> dbrow( $query );
		$query = $database -> dbquery( "SELECT contactcat_position FROM " . DB_PREFIX . "esselbach_ct_contactscats WHERE contactcat_id = '" . $options[ 1 ] . "'" );
		list( $current_position ) = $database -> dbrow( $query );
		
		if( $current_position == $end_position )
		{
			$html -> login( $words_contacts[ 'EDIT_CATEGORY' ], $words_contacts[ 'CAT_ALREADY_LAST' ], "index.php?action=contactcategories" );
		}
		else
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_contactscats SET contactcat_position = contactcat_position + 1 WHERE contactcat_id = '" . $options[ 1 ] . "'" );
			$html -> login( $words_contacts[ 'EDIT_CATEGORY' ], $words_contacts[ 'CAT_DECREASED_PRIORITY' ], "index.php?action=contactcategories" );
		}
	}

	if( !$options[ 0 ] )
	{
		
		$security_hash = $system -> adminhashput();
		
		$html -> makeheader( $words_contacts[ 'CONTACT_CATEGORIES' ] );
		$html -> deleteinit( $words_contacts[ 'ARE_YOU_SURE' ] );
		$html -> makesubheader();
		$html -> makegroupmenu( "contacts" );
		$html -> makeformheader( $words_contacts[ 'CONTACT_CATEGORIES' ], "categories", "doordercategories", "post" );
		$html -> tableheader( $words_contacts[ 'CATEGORY_SITEID' ], $words_contacts[ 'CATEGORY' ] );
		$query = $database -> dbquery( "SELECT contactcat_id, contactcat_website, contactcat_name, contactcat_parentid, contactcat_position FROM " . DB_PREFIX . "esselbach_ct_contactscats ORDER BY contactcat_position, contactcat_parentcat, contactcat_id" );
		
		while( list( $contactcat_id, $contactcat_website, $contactcat_name, $contactcat_parentid, $contactcat_position ) = $database -> dbrow( $query ) )
		{
			
			if( $contactcat_parentid > 1 )
			{
				$contactcat_name = str_repeat( "-", $contactcat_parentid ) . " " . $contactcat_name;
			}
			
			$html -> tablemiddle( $contactcat_id . " / " . $contactcat_website, $contactcat_name . " <a href=\"index.php?action=contactcategories&amp;opts=upcat-" . $contactcat_id . "-" . $security_hash . "\"><img src=\"../images/up.gif\" alt=\"up\" /></a> <a href=\"index.php?action=contactcategories&amp;opts=downcat-" . $contactcat_id . "-" . $security_hash . "\"><img src=\"../images/down.gif\" alt=\"down\" /></a> (" . $words_contacts[ 'PRIORITY' ] . ": <input name=\"input_priority[" . $contactcat_id . "]\" size=\"3\" value=\"" . $contactcat_position . "\" />)", "contactcategories&amp;opts=editcat-" . $contactcat_id . "-" . $security_hash, "contactcategories&amp;opts=deletecat-" . $contactcat_id . "-" . $security_hash );
		}

		$html -> table5col( "<input type=\"hidden\" name=\"input_security_hash\" value=\"" . $security_hash . "\" /><input type=\"hidden\" name=\"aform\" value=\"doupdatecontactscategories\" /><input type=\"submit\" value=\"" . $words_contacts[ 'UPDATE_PRIORITY' ] . "\" /><input type=\"submit\" name=\"input_doalphabetically\" value=\"" . $words_contacts[ 'ORDER_ALPHABETICALLY' ] . "\" /></form>" );
		
		$html -> maketablefooter();
		$html -> makeformsub( $words_contacts[ 'ADD_A_NEW_CATEGORY' ] );
		$websites = array();
		$query = $database -> dbquery( "SELECT preference_website, preference_value FROM " . DB_PREFIX . "esselbach_ct_preferences WHERE preference_key = 'WEBSITE_NAME'" );
		
		if( $database -> dbrows( $query ) )
		{
			echo "<strong>" . $words_contacts[ 'WEBSITE' ] . ":</strong> <select size=\"1\" name=\"input_category_website\">";
			echo "<option value=\"0\">" . $words_contacts[ 'ALL' ] . "</option>";
			
			while( list( $website_id, $website_name ) = $database -> dbrow( $query ) )
			{
				echo "<option value=\"" . $website_id . "\">" . $website_name . "</option>";
				$websites[ $website_id ] = $website_name;
			}
			
			echo "</select><br />";
		}
		
		$html -> makeeoption( $words_contacts[ 'CATEGORY_NAME' ], "input_category_name", "" );
		echo "<strong>" . $words_contacts[ 'PARENT_CATEGORY' ] . ":</strong><br /><select size=\"1\" name=\"input_category_parent\">";
		echo "<option value=\"0\">" . $words_contacts[ 'NONE' ] . "</option>";
		$query = $database -> dbquery( "SELECT contactcat_id, contactcat_website, contactcat_name, contactcat_parentid FROM " . DB_PREFIX . "esselbach_ct_contactscats ORDER BY contactcat_position, contactcat_id" );
		
		while( list( $contactcat_id, $contactcat_website, $contactcat_name, $contactcat_parentid ) = $database -> dbrow( $query ) )
		{
			
			if( $contactcat_parentid > 1 )
			{
				$contactcat_name = str_repeat( "-", $contactcat_parentid ) . " " . $contactcat_name;
			}
			
			
			if( isset( $websites[ $contactcat_website ] ) )
			{
				$contactcat_website = " (" . $websites[ $contactcat_website ] . ")";
			}
			else
			{
				$contactcat_website = "";
			}
			
			echo "<option value=\"" . $contactcat_id . "\">" . $contactcat_name . $contactcat_website . "</option>";
		}
		
		echo "</select>";
		echo "<br /><input type=\"hidden\" name=\"input_security_hash\" value=\"" . $security_hash . "\" /><input type=\"hidden\" name=\"aform\" value=\"doaddcontactcategory\" /><input type=\"submit\" value=\"" . $words_contacts[ 'SUBMIT' ] . "\" />";
		$html -> makeformfooter();
	}
}
?>