<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.0                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 529     Patch: 11                                                 |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Files
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function AdminFilesCategories
 * A function to manage file categories
 * @author Philipp Louis Esselbach
 */
function AdminFilesCategories( $opts )
{
	global $database, $system, $security, $html, $words_files;
	$options = explode( "-", $opts );
	$options[ 0 ] = ( isset( $options[ 0 ] ) ) ? $security -> checkvar( $options[ 0 ] ) : "" ;
	$options[ 1 ] = ( isset( $options[ 1 ] ) ) ? $security -> checknum( $options[ 1 ] ) : "" ;
	$options[ 2 ] = ( isset( $options[ 2 ] ) ) ? $security -> checkvar( $options[ 2 ] ) : "" ;
	
	if( $options[ 0 ] )
	{
		if( $system -> adminhashget() != $options[ 2 ] )
		{
			$html -> login( $words_files[ 'ERROR' ], $words_files[ 'INVALID_SESSION' ], "index.php" );
			exit;
		}
	}

	if( $options[ 0 ] == "deletecat" )
	{
		$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_filescats WHERE filecat_id='" . $options[ 1 ] . "'" );
		$html -> login( $words_files[ 'EDIT_CATEGORY' ], $words_files[ 'CATEGORY_REMOVED' ], "index.php?action=filescategories" );
	}

	if( $options[ 0 ] == "editcat" )
	{
		$query = $database -> dbquery( "SELECT filecat_id, filecat_website, filecat_name, filecat_seo, filecat_description, filecat_keywords, filecat_parentcat FROM " . DB_PREFIX . "esselbach_ct_filescats WHERE filecat_id = '" . $options[ 1 ] . "'" );
		list( $filecat_id, $filecat_website, $filecat_name, $filecat_seo, $filecat_description, $filecat_keywords, $filecat_parentcat ) = $database -> dbrow( $query );
		$html -> makeheader( $words_files[ 'EDIT_CATEGORY' ] );
		$html -> deleteinit( $words_files[ 'ARE_YOU_SURE' ] );
		$html -> makesubheader();
		$html -> makegroupmenu( "files" );
		$html -> makeformheader( $words_files[ 'EDIT_CATEGORY' ], "edit", "editform", "post" );
		$websites = array();
		$query = $database -> dbquery( "SELECT preference_website, preference_value FROM " . DB_PREFIX . "esselbach_ct_preferences WHERE preference_key = 'WEBSITE_NAME'" );
		
		if( $database -> dbrows( $query ) )
		{
			echo "<strong>" . $words_files[ 'WEBSITE' ] . ":</strong> <select size=\"1\" name=\"input_category_website\">";
			echo "<option value=\"0\">" . $words_files[ 'ALL' ] . "</option>";
			
			while( list( $website_id, $website_name ) = $database -> dbrow( $query ) )
			{
				if( $website_id == $filecat_website )
				{
					echo "<option selected=\"selected\" value=\"" . $website_id . "\">" . $website_name . "</option>";
				}
				else
				{
					echo "<option value=\"" . $website_id . "\">" . $website_name . "</option>";
				}
				
				$websites[ $website_id ] = $website_name;
			}
			
			echo "</select> ";
		}
		
		echo "<strong>" . $words_files[ 'PARENT_CATEGORY' ] . ":</strong><select size=\"1\" name=\"input_category_parent\">";
		echo "<option value=\"0\">" . $words_files[ 'NONE' ] . "</option>";
		$query = $database -> dbquery( "SELECT filecat_id, filecat_website, filecat_name, filecat_parentid FROM " . DB_PREFIX . "esselbach_ct_filescats WHERE NOT(filecat_id = '" . $filecat_id . "') ORDER BY filecat_position, filecat_parentcat, filecat_id" );
		
		while( list( $filecat_pid, $filecat_parentwebsite, $filecat_parentname, $filecat_parentid ) = $database -> dbrow( $query ) )
		{
			
			if( $filecat_parentid > 1 )
			{
				$filecat_parentname = str_repeat( "-", $filecat_parentid ) . " " . $filecat_parentname;
			}
			
			
			if( isset( $websites[ $filecat_website ] ) )
			{
				$filecat_parentwebsite = " (" . $websites[ $filecat_parentwebsite ] . ")";
			}
			else
			{
				$filecat_parentwebsite = "";
			}
			
			
			if( $filecat_parentcat == $filecat_pid )
			{
				echo "<option selected=\"selected\" value=\"" . $filecat_pid . "\">" . $filecat_parentname . $filecat_parentwebsite . "</option>";
			}
			else
			{
				echo "<option value=\"" . $filecat_pid . "\">" . $filecat_parentname . $filecat_parentwebsite . "</option>";
			}
		}
		
		echo "</select><br />";
		$html -> uppertext( $words_files[ 'CATEGORY_NAME' ], "input_category_name", $filecat_name );
		$html -> uppertext( $words_files[ 'CATEGORY_DESCRIPTION' ], "input_category_description", $filecat_description );
		$html -> uppertext( $words_files[ 'CATEGORY_KEYWORDS' ], "input_category_keywords", $filecat_keywords );
		$html -> uppertext( $words_files[ 'CATEGORY_SEO_URL' ], "input_category_seo", $filecat_seo );
		echo "<input type=\"hidden\" name=\"input_security_hash\" value=\"" . $options[ 2 ] . "\" /><input type=\"hidden\" name=\"aform\" value=\"doeditfilescategory\" /><input type=\"hidden\" name=\"input_category_id\" value=\"" . $filecat_id . "\" /><input type=\"submit\" value=\"" . $words_files[ 'SUBMIT' ] . "\" />";
		$query = $database -> dbquery( "SELECT filecat_id, filecat_name FROM " . DB_PREFIX . "esselbach_ct_filescats WHERE filecat_parentcat = '" . $options[ 1 ] . "' ORDER BY filecat_position" );
		
		if( $database -> dbrows( $query ) )
		{
			$html -> tableheader( $words_files[ 'ID' ], $words_files[ 'SUBCATEGORY' ] );
			
			while( list( $filecat_id, $filecat_name ) = $database -> dbrow( $query ) )
			{
				$html -> tablemiddle( $filecat_id, $filecat_name, "filescategories&amp;opts=editcat-" . $filecat_id . "-" . $options[ 2 ], "filescategories&amp;opts=deletecat-" . $filecat_id . "-" . $options[ 2 ] );
			}
			
			$html -> maketablefooter();
		}
		
		$html -> makeformfooter();
	}

	if( $options[ 0 ] == "upcat" )
	{
		$query = $database -> dbquery( "SELECT filecat_position FROM " . DB_PREFIX . "esselbach_ct_filescats WHERE filecat_id = '" . $options[ 1 ] . "'" );
		list( $position ) = $database -> dbrow( $query );
		
		if( $position == 1 )
		{
			$html -> login( $words_files[ 'EDIT_CATEGORY' ], $words_files[ 'CAT_ALREADY_TOP' ], "index.php?action=filescategories" );
		}
		else
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_filescats SET filecat_position = filecat_position - 1 WHERE filecat_id = '" . $options[ 1 ] . "'" );
			$html -> login( $words_files[ 'EDIT_CATEGORY' ], $words_files[ 'CAT_INCREASED_PRIORITY' ], "index.php?action=filescategories" );
		}
	}

	if( $options[ 0 ] == "downcat" )
	{
		$query = $database -> dbquery( "SELECT COUNT(filecat_id) FROM " . DB_PREFIX . "esselbach_ct_filescats" );
		list( $end_position ) = $database -> dbrow( $query );
		$query = $database -> dbquery( "SELECT filecat_position FROM " . DB_PREFIX . "esselbach_ct_filescats WHERE filecat_id = '" . $options[ 1 ] . "'" );
		list( $current_position ) = $database -> dbrow( $query );
		
		if( $current_position == $end_position )
		{
			$html -> login( $words_files[ 'EDIT_CATEGORY' ], $words_files[ 'CAT_ALREADY_LAST' ], "index.php?action=filescategories" );
		}
		else
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_filescats SET filecat_position = filecat_position + 1 WHERE filecat_id = '" . $options[ 1 ] . "'" );
			$html -> login( $words_files[ 'EDIT_CATEGORY' ], $words_files[ 'CAT_DECREASED_PRIORITY' ], "index.php?action=filescategories" );
		}
	}

	if( !$options[ 0 ] )
	{
		
		$security_hash = $system -> adminhashput();
		
		$html -> makeheader( $words_files[ 'FILES_CATEGORIES' ] );
		$html -> deleteinit( $words_files[ 'ARE_YOU_SURE' ] );
		$html -> makesubheader();
		$html -> makegroupmenu( "files" );
		$html -> makeformheader( $words_files[ 'FILES_CATEGORIES' ], "categories", "doordercategories", "post" );
		$html -> tableheader( $words_files[ 'CATEGORY_SITEID' ], $words_files[ 'CATEGORY' ] );
		$query = $database -> dbquery( "SELECT filecat_id, filecat_website, filecat_name, filecat_parentid, filecat_position FROM " . DB_PREFIX . "esselbach_ct_filescats ORDER BY filecat_position, filecat_parentcat, filecat_id" );
		
		while( list( $filecat_id, $filecat_website, $filecat_name, $filecat_parentid, $filecat_position ) = $database -> dbrow( $query ) )
		{
			
			if( $filecat_parentid > 1 )
			{
				$filecat_name = str_repeat( "-", $filecat_parentid ) . " " . $filecat_name;
			}
			
			$html -> tablemiddle( $filecat_id . " / " . $filecat_website, $filecat_name . " <a href=\"index.php?action=filescategories&amp;opts=upcat-" . $filecat_id . "-" . $security_hash . "\"><img src=\"../images/up.gif\" alt=\"up\" /></a> <a href=\"index.php?action=filescategories&amp;opts=downcat-" . $filecat_id . "-" . $security_hash . "\"><img src=\"../images/down.gif\" alt=\"down\" /></a> (" . $words_files[ 'PRIORITY' ] . ": <input name=\"input_priority[" . $filecat_id . "]\" size=\"3\" value=\"" . $filecat_position . "\" />)", "filescategories&amp;opts=editcat-" . $filecat_id . "-" . $security_hash, "filescategories&amp;opts=deletecat-" . $filecat_id . "-" . $security_hash );
		}
		
		$html -> table5col( "<input type=\"hidden\" name=\"input_security_hash\" value=\"" . $security_hash . "\" /><input type=\"hidden\" name=\"aform\" value=\"doupdatefilescategories\" /><input type=\"submit\" value=\"" . $words_files[ 'UPDATE_PRIORITY' ] . "\" /><input type=\"submit\" name=\"input_doalphabetically\" value=\"" . $words_files[ 'ORDER_ALPHABETICALLY' ] . "\" /></form>" );
		
		$html -> maketablefooter();
		$html -> makeformsub( $words_files[ 'ADD_A_NEW_CATEGORY' ] );
		$websites = array();
		$query = $database -> dbquery( "SELECT preference_website, preference_value FROM " . DB_PREFIX . "esselbach_ct_preferences WHERE preference_key = 'WEBSITE_NAME'" );
		
		if( $database -> dbrows( $query ) )
		{
			echo "<strong>" . $words_files[ 'WEBSITE' ] . ":</strong> <select size=\"1\" name=\"input_category_website\">";
			echo "<option value=\"0\">" . $words_files[ 'ALL' ] . "</option>";
			
			while( list( $website_id, $website_name ) = $database -> dbrow( $query ) )
			{
				echo "<option value=\"" . $website_id . "\">" . $website_name . "</option>";
				$websites[ $website_id ] = $website_name;
			}
			
			echo "</select><br />";
		}
		
		$html -> makeeoption( $words_files[ 'CATEGORY_NAME' ], "input_category_name", "" );
		$html -> makeeoption( $words_files[ 'CATEGORY_DESCRIPTION' ], "input_category_description", "" );
		$html -> makeeoption( $words_files[ 'CATEGORY_KEYWORDS' ], "input_category_keywords", "" );
		$html -> makeeoption( $words_files[ 'CATEGORY_SEO_URL' ], "input_category_seo", "" );
		echo "<strong>" . $words_files[ 'PARENT_CATEGORY' ] . ":</strong><br /><select size=\"1\" name=\"input_category_parent\">";
		echo "<option value=\"0\">" . $words_files[ 'NONE' ] . "</option>";
		$query = $database -> dbquery( "SELECT filecat_id, filecat_website, filecat_name, filecat_parentid FROM " . DB_PREFIX . "esselbach_ct_filescats ORDER BY filecat_position, filecat_parentcat, filecat_id" );
		
		while( list( $filecat_id, $filecat_website, $filecat_name, $filecat_parentid ) = $database -> dbrow( $query ) )
		{
			
			if( $filecat_parentid > 1 )
			{
				$filecat_name = str_repeat( "-", $filecat_parentid ) . " " . $filecat_name;
			}
			
			
			if( isset( $websites[ $filecat_website ] ) )
			{
				$filecat_website = " (" . $websites[ $filecat_website ] . ")";
			}
			else
			{
				$filecat_website = "";
			}
			
			echo "<option value=\"" . $filecat_id . "\">" . $filecat_name . $filecat_website . "</option>";
		}
		
		echo "</select>";
		echo "<br /><input type=\"hidden\" name=\"input_security_hash\" value=\"" . $security_hash . "\" /><input type=\"hidden\" name=\"aform\" value=\"doaddfilescategory\" /><input type=\"submit\" value=\"" . $words_files[ 'SUBMIT' ] . "\" />";
		$html -> makeformfooter();
	}
}
?>