<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.0                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 529     Patch: 11                                                 |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Knowledgebase
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function AdminDoUpdateKnowledgebaseCategories
 * A function to update the priority of the knowledegbase categories 
 * @author Philipp Louis Esselbach
 */
function AdminDoUpdateKnowledgebaseCategories()
{
	global $security, $database, $system, $html, $preferences, $words_knowledgebase;
	$input_priority = ( isset( $_POST[ 'input_priority' ] ) ) ? $security -> checkvararray( $_POST[ 'input_priority' ] ) : "" ;
	$input_doalphabetically = ( isset( $_POST[ 'input_doalphabetically' ] ) ) ? $security -> checkvar( $_POST[ 'input_doalphabetically' ] ) : "" ;	
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;

	if( ( $system -> adminhashget() != $input_security_hash ) and( $preferences[ 'website_subsessions_admin' ] ) )
	{
		$html -> login( $words_knowledgebase[ 'ERROR' ], $words_knowledgebase[ 'INVALID_SESSION' ], "index.php" );
		exit;
	}

	if ( $input_doalphabetically )
	{
		$priority = 1;
		$query = $database -> dbquery("SELECT knowledgebasecat_id FROM ".DB_PREFIX."esselbach_ct_knowledgebasecats ORDER BY knowledgebasecat_name");
		while( list( $knowledgebasecat_id ) = $database -> dbrow( $query ) )
		{
			$database -> dbquery( "UPDATE ".DB_PREFIX."esselbach_ct_knowledgebasecats SET knowledgebasecat_position = '" . $priority . "' WHERE knowledgebasecat_id = '" . intval( $knowledgebasecat_id ) . "'");
			$priority++;
		}
	}
	else
	{
		if( is_array( $input_priority ) )
		{
			$query = $database -> dbquery("SELECT knowledgebasecat_id FROM ".DB_PREFIX."esselbach_ct_knowledgebasecats ORDER BY knowledgebasecat_id DESC LIMIT 1");
			list( $top_position ) = $database -> dbrow( $query);
			
			$keys = array_keys( $input_priority );
			foreach ($keys as $key)
			{
				$value = $input_priority[ intval( $key ) ];
				
				if ( $value > $top_position )
				{
					$value = $top_position;
				}
				if ( $value < 1)
				{
					$value = 1;
				}
				
				$database -> dbquery( "UPDATE ".DB_PREFIX."esselbach_ct_knowledgebasecats SET knowledgebasecat_position = '" . intval( $value ) . "' WHERE knowledgebasecat_id = '" . intval( $key ) . "'");
			}
		}
	}
	$html -> login( $words_knowledgebase[ 'KNOWLEDGEBASE' ], $words_knowledgebase[ 'PRIORITY_UPDATED' ], "index.php?action=knowledgebasecategories" );	
}
?>