<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.0                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 529     Patch: 11                                                 |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Knowledgebase
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function AdminKnowledgebaseCategory
 * A function to manage knowledgebase categories 
 * @author Philipp Louis Esselbach
 */
function AdminKnowledgebaseCategories( $opts )
{
	global $database, $system, $security, $preferences, $html, $words_knowledgebase;
	$options = explode( "-", $opts );
	$options[ 0 ] = ( isset( $options[ 0 ] ) ) ? $security -> checkvar( $options[ 0 ] ) : "" ;
	$options[ 1 ] = ( isset( $options[ 1 ] ) ) ? $security -> checknum( $options[ 1 ] ) : "" ;
	$options[ 2 ] = ( isset( $options[ 2 ] ) ) ? $security -> checkvar( $options[ 2 ] ) : "" ;
	
	if( $options[ 0 ] )
	{
		if( ( $system -> adminhashget() != $options[ 2 ] ) and( $preferences[ 'website_subsessions_admin' ] ) )
		{
			$html -> login( $words_knowledgebase[ 'ERROR' ], $words_knowledgebase[ 'INVALID_SESSION' ], "index.php" );
			exit;
		}
	}

	if( $options[ 0 ] == "deletecat" )
	{
		$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_knowledgebasecats WHERE knowledgebasecat_id='" . $options[ 1 ] . "'" );
		$html -> login( $words_knowledgebase[ 'EDIT_CATEGORY' ], $words_knowledgebase[ 'CATEGORY_REMOVED' ], "index.php?action=knowledgebasecategories" );
	}

	if( $options[ 0 ] == "editcat" )
	{
		$query = $database -> dbquery( "SELECT knowledgebasecat_id, knowledgebasecat_website, knowledgebasecat_name, knowledgebasecat_seo, knowledgebasecat_description, knowledgebasecat_keywords, knowledgebasecat_parentcat FROM " . DB_PREFIX . "esselbach_ct_knowledgebasecats WHERE knowledgebasecat_id = '" . $options[ 1 ] . "'" );
		list( $knowledgebasecat_id, $knowledgebasecat_website, $knowledgebasecat_name, $knowledgebasecat_seo, $knowledgebasecat_description, $knowledgebasecat_keywords, $knowledgebasecat_parentcat ) = $database -> dbrow( $query );
		$html -> makeheader( $words_knowledgebase[ 'EDIT_CATEGORY' ] );
		$html -> deleteinit( $words_knowledgebase[ 'ARE_YOU_SURE' ] );
		$html -> makesubheader();
		$html -> makegroupmenu( "knowledgebase" );
		$html -> makeformheader( $words_knowledgebase[ 'EDIT_CATEGORY' ], "edit", "editform", "post" );
		$websites = array();
		$query = $database -> dbquery( "SELECT preference_website, preference_value FROM " . DB_PREFIX . "esselbach_ct_preferences WHERE preference_key = 'WEBSITE_NAME'" );
		
		if( $database -> dbrows( $query ) )
		{
			echo "<strong>" . $words_knowledgebase[ 'WEBSITE' ] . ":</strong> <select size=\"1\" name=\"input_category_website\">";
			echo "<option value=\"0\">" . $words_knowledgebase[ 'ALL' ] . "</option>";
			
			while( list( $website_id, $website_name ) = $database -> dbrow( $query ) )
			{
				if( $website_id == $knowledgebasecat_website )
				{
					echo "<option selected=\"selected\" value=\"" . $website_id . "\">" . $website_name . "</option>";
				}
				else
				{
					echo "<option value=\"" . $website_id . "\">" . $website_name . "</option>";
				}
				
				$websites[ $website_id ] = $website_name;
			}
			
			echo "</select> ";
		}
		
		echo "<strong>" . $words_knowledgebase[ 'PARENT_CATEGORY' ] . ":</strong><select size=\"1\" name=\"input_category_parent\">";
		echo "<option value=\"0\">" . $words_knowledgebase[ 'NONE' ] . "</option>";
		$query = $database -> dbquery( "SELECT knowledgebasecat_id, knowledgebasecat_website, knowledgebasecat_name, knowledgebasecat_parentid FROM " . DB_PREFIX . "esselbach_ct_knowledgebasecats WHERE NOT(knowledgebasecat_id = '" . $knowledgebasecat_id . "') ORDER BY knowledgebasecat_position, knowledgebasecat_parentcat, knowledgebasecat_id" );
		
		while( list( $knowledgebasecat_pid, $knowledgebasecat_parentwebsite, $knowledgebasecat_parentname, $knowledgebasecat_parentid ) = $database -> dbrow( $query ) )
		{
			
			if( $knowledgebasecat_parentid > 1 )
			{
				$knowledgebasecat_parentname = str_repeat( "-", $knowledgebasecat_parentid ) . " " . $knowledgebasecat_parentname;
			}
			
			
			if( isset( $websites[ $knowledgebasecat_website ] ) )
			{
				$knowledgebasecat_parentwebsite = " (" . $websites[ $knowledgebasecat_parentwebsite ] . ")";
			}
			else
			{
				$knowledgebasecat_parentwebsite = "";
			}
			
			
			if( $knowledgebasecat_parentcat == $knowledgebasecat_pid )
			{
				echo "<option selected=\"selected\" value=\"" . $knowledgebasecat_pid . "\">" . $knowledgebasecat_parentname . $knowledgebasecat_parentwebsite . "</option>";
			}
			else
			{
				echo "<option value=\"" . $knowledgebasecat_pid . "\">" . $knowledgebasecat_parentname . $knowledgebasecat_parentwebsite . "</option>";
			}
		}
		
		echo "</select><br />";
		$html -> uppertext( $words_knowledgebase[ 'CATEGORY_NAME' ], "input_category_name", $knowledgebasecat_name );
		$html -> uppertext( $words_knowledgebase[ 'CATEGORY_DESCRIPTION' ], "input_category_description", $knowledgebasecat_description );
		$html -> uppertext( $words_knowledgebase[ 'CATEGORY_KEYWORDS' ], "input_category_keywords", $knowledgebasecat_keywords );
		$html -> uppertext( $words_knowledgebase[ 'CATEGORY_SEO_URL' ], "input_category_seo", $knowledgebasecat_seo );
		echo "<input type=\"hidden\" name=\"input_security_hash\" value=\"" . $options[ 2 ] . "\" /><input type=\"hidden\" name=\"aform\" value=\"doeditknowledgebasecategory\" /><input type=\"hidden\" name=\"input_category_id\" value=\"" . $knowledgebasecat_id . "\" /><input type=\"submit\" value=\"" . $words_knowledgebase[ 'SUBMIT' ] . "\" />";
		$query = $database -> dbquery( "SELECT knowledgebasecat_id, knowledgebasecat_name FROM " . DB_PREFIX . "esselbach_ct_knowledgebasecats WHERE knowledgebasecat_parentcat = '" . $options[ 1 ] . "' ORDER BY knowledgebasecat_position" );
		
		if( $database -> dbrows( $query ) )
		{
			$html -> tableheader( $words_knowledgebase[ 'ID' ], $words_knowledgebase[ 'SUBCATEGORY' ] );
			
			while( list( $knowledgebasecat_id, $knowledgebasecat_name ) = $database -> dbrow( $query ) )
			{
				$html -> tablemiddle( $knowledgebasecat_id, $knowledgebasecat_name, "knowledgebasecategories&amp;opts=editcat-" . $knowledgebasecat_id . "-" . $options[ 2 ], "knowledgecategories&amp;opts=deletecat-" . $knowledgebasecat_id . "-" . $options[ 2 ] );
			}
			
			$html -> maketablefooter();
		}
		
		$html -> makeformfooter();
	}

	if( $options[ 0 ] == "upcat" )
	{
		$query = $database -> dbquery( "SELECT knowledgebasecat_position FROM " . DB_PREFIX . "esselbach_ct_knowledgebasecats WHERE knowledgebasecat_id = '" . $options[ 1 ] . "'" );
		list( $position ) = $database -> dbrow( $query );
		
		if( $position == 1 )
		{
			$html -> login( $words_knowledgebase[ 'EDIT_CATEGORY' ], $words_knowledgebase[ 'CAT_ALREADY_TOP' ], "index.php?action=knowledgebasecategories" );
		}
		else
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_knowledgebasecats SET knowledgebasecat_position = knowledgebasecat_position - 1 WHERE knowledgebasecat_id = '" . $options[ 1 ] . "'" );
			$html -> login( $words_knowledgebase[ 'EDIT_CATEGORY' ], $words_knowledgebase[ 'CAT_INCREASED_PRIORITY' ], "index.php?action=knowledgebasecategories" );
		}
	}

	if( $options[ 0 ] == "downcat" )
	{
		$query = $database -> dbquery( "SELECT COUNT(knowledgebasecat_id) FROM " . DB_PREFIX . "esselbach_ct_knowledgebasecats" );
		list( $end_position ) = $database -> dbrow( $query );
		$query = $database -> dbquery( "SELECT knowledgebasecat_position FROM " . DB_PREFIX . "esselbach_ct_knowledgebasecats WHERE knowledgebasecat_id = '" . $options[ 1 ] . "'" );
		list( $current_position ) = $database -> dbrow( $query );
		
		if( $current_position == $end_position )
		{
			$html -> login( $words_knowledgebase[ 'EDIT_CATEGORY' ], $words_knowledgebase[ 'CAT_ALREADY_LAST' ], "index.php?action=knowledgebasecategories" );
		}
		else
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_knowledgebasecats SET knowledgebasecat_position = knowledgebasecat_position + 1 WHERE knowledgebasecat_id = '" . $options[ 1 ] . "'" );
			$html -> login( $words_knowledgebase[ 'EDIT_CATEGORY' ], $words_knowledgebase[ 'CAT_DECREASED_PRIORITY' ], "index.php?action=knowledgebasecategories" );
		}
	}

	if( !$options[ 0 ] )
	{
		
		$security_hash = $system -> adminhashput();
		
		$html -> makeheader( $words_knowledgebase[ 'KNOWLEDGEBASE_CATEGORIES' ] );
		$html -> deleteinit( $words_knowledgebase[ 'ARE_YOU_SURE' ] );
		$html -> makesubheader();
		$html -> makegroupmenu( "knowledgebase" );
		$html -> makeformheader( $words_knowledgebase[ 'KNOWLEDGEBASE_CATEGORIES' ], "categories", "doordercategories", "post" );
		$html -> tableheader( $words_knowledgebase[ 'CATEGORY_SITEID' ], $words_knowledgebase[ 'CATEGORY' ] );
		$query = $database -> dbquery( "SELECT knowledgebasecat_id, knowledgebasecat_website, knowledgebasecat_name, knowledgebasecat_parentid, knowledgebasecat_position FROM " . DB_PREFIX . "esselbach_ct_knowledgebasecats ORDER BY knowledgebasecat_position, knowledgebasecat_parentcat, knowledgebasecat_id" );
		
		while( list( $knowledgebasecat_id, $knowledgebasecat_website, $knowledgebasecat_name, $knowledgebasecat_parentid, $knowledgebasecat_position ) = $database -> dbrow( $query ) )
		{
			
			if( $knowledgebasecat_parentid > 1 )
			{
				$knowledgebasecat_name = str_repeat( "-", $knowledgebasecat_parentid ) . " " . $knowledgebasecat_name;
			}
			
			$html -> tablemiddle( $knowledgebasecat_id . " / " . $knowledgebasecat_website, $knowledgebasecat_name . " <a href=\"index.php?action=knowledgebasecategories&amp;opts=upcat-" . $knowledgebasecat_id . "-" . $security_hash . "\"><img src=\"../images/up.gif\" alt=\"up\" /></a> <a href=\"index.php?action=knowledgebasecategories&amp;opts=downcat-" . $knowledgebasecat_id . "-" . $security_hash . "\"><img src=\"../images/down.gif\" alt=\"down\" /></a> (" . $words_knowledgebase[ 'PRIORITY' ] . ": <input name=\"input_priority[" . $knowledgebasecat_id . "]\" size=\"3\" value=\"" . $knowledgebasecat_position . "\" />)", "knowledgebasecategories&amp;opts=editcat-" . $knowledgebasecat_id . "-" . $security_hash, "knowledgebasecategories&amp;opts=deletecat-" . $knowledgebasecat_id . "-" . $security_hash );
		}

		$html -> table5col( "<input type=\"hidden\" name=\"input_security_hash\" value=\"" . $security_hash . "\" /><input type=\"hidden\" name=\"aform\" value=\"doupdateknowledgebasecategories\" /><input type=\"submit\" value=\"" . $words_knowledgebase[ 'UPDATE_PRIORITY' ] . "\" /><input type=\"submit\" name=\"input_doalphabetically\" value=\"" . $words_knowledgebase[ 'ORDER_ALPHABETICALLY' ] . "\" /></form>" );
		
		$html -> maketablefooter();
		$html -> makeformsub( $words_knowledgebase[ 'ADD_A_NEW_CATEGORY' ] );
		$websites = array();
		$query = $database -> dbquery( "SELECT preference_website, preference_value FROM " . DB_PREFIX . "esselbach_ct_preferences WHERE preference_key = 'WEBSITE_NAME'" );
		
		if( $database -> dbrows( $query ) )
		{
			echo "<strong>" . $words_knowledgebase[ 'WEBSITE' ] . ":</strong> <select size=\"1\" name=\"input_category_website\">";
			echo "<option value=\"0\">" . $words_knowledgebase[ 'ALL' ] . "</option>";
			
			while( list( $website_id, $website_name ) = $database -> dbrow( $query ) )
			{
				echo "<option value=\"" . $website_id . "\">" . $website_name . "</option>";
				$websites[ $website_id ] = $website_name;
			}
			
			echo "</select><br />";
		}
		
		$html -> makeeoption( $words_knowledgebase[ 'CATEGORY_NAME' ], "input_category_name", "" );
		$html -> makeeoption( $words_knowledgebase[ 'CATEGORY_DESCRIPTION' ], "input_category_description", "" );
		$html -> makeeoption( $words_knowledgebase[ 'CATEGORY_KEYWORDS' ], "input_category_keywords", "" );
		$html -> makeeoption( $words_knowledgebase[ 'CATEGORY_SEO_URL' ], "input_category_seo", "" );
		echo "<strong>" . $words_knowledgebase[ 'PARENT_CATEGORY' ] . ":</strong><br /><select size=\"1\" name=\"input_category_parent\">";
		echo "<option value=\"0\">" . $words_knowledgebase[ 'NONE' ] . "</option>";
		$query = $database -> dbquery( "SELECT knowledgebasecat_id, knowledgebasecat_website, knowledgebasecat_name, knowledgebasecat_parentid FROM " . DB_PREFIX . "esselbach_ct_knowledgebasecats ORDER BY knowledgebasecat_position, knowledgebasecat_parentcat, knowledgebasecat_id" );
		
		while( list( $knowledgebasecat_id, $knowledgebasecat_website, $knowledgebasecat_name, $knowledgebasecat_parentid ) = $database -> dbrow( $query ) )
		{
			
			if( $knowledgebasecat_parentid > 1 )
			{
				$knowledgebasecat_name = str_repeat( "-", $knowledgebasecat_parentid ) . " " . $knowledgebasecat_name;
			}
			
			
			if( isset( $websites[ $knowledgebasecat_website ] ) )
			{
				$knowledgebasecat_website = " (" . $websites[ $knowledgebasecat_website ] . ")";
			}
			else
			{
				$knowledgebasecat_website = "";
			}
			
			echo "<option value=\"" . $knowledgebasecat_id . "\">" . $knowledgebasecat_name . $knowledgebasecat_website . "</option>";
		}
		
		echo "</select>";
		echo "<br /><input type=\"hidden\" name=\"input_security_hash\" value=\"" . $security_hash . "\" /><input type=\"hidden\" name=\"aform\" value=\"doaddknowledgebasecategory\" /><input type=\"submit\" value=\"" . $words_knowledgebase[ 'SUBMIT' ] . "\" />";
		$html -> makeformfooter();
	}
}
?>