<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.0                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 529     Patch: 11                                                 |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Links
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function AdminLinksCategories
 * A function to manage links categories 
 * @author Philipp Louis Esselbach
 */
function AdminLinksCategories( $opts )
{
	global $database, $system, $security, $preferences, $html, $words_links;
	$options = explode( "-", $opts );
	$options[ 0 ] = ( isset( $options[ 0 ] ) ) ? $security -> checkvar( $options[ 0 ] ) : "" ;
	$options[ 1 ] = ( isset( $options[ 1 ] ) ) ? $security -> checknum( $options[ 1 ] ) : "" ;
	$options[ 2 ] = ( isset( $options[ 2 ] ) ) ? $security -> checkvar( $options[ 2 ] ) : "" ;
	
	if( $options[ 0 ] )
	{
		if( ( $system -> adminhashget() != $options[ 2 ] ) and( $preferences[ 'website_subsessions_admin' ] ) )
		{
			$html -> login( $words_links[ 'ERROR' ], $words_links[ 'INVALID_SESSION' ], "index.php" );
			exit;
		}
	}

	if( $options[ 0 ] == "deletecat" )
	{
		$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_linkscats WHERE linkcat_id='" . $options[ 1 ] . "'" );
		$html -> login( $words_links[ 'EDIT_CATEGORY' ], $words_links[ 'CATEGORY_REMOVED' ], "index.php?action=linkscategories" );
	}

	if( $options[ 0 ] == "editcat" )
	{
		$query = $database -> dbquery( "SELECT linkcat_id, linkcat_website, linkcat_name, linkcat_seo, linkcat_description, linkcat_keywords, linkcat_parentcat FROM " . DB_PREFIX . "esselbach_ct_linkscats WHERE linkcat_id = '" . $options[ 1 ] . "'" );
		list( $linkcat_id, $linkcat_website, $linkcat_name, $linkcat_seo, $linkcat_description, $linkcat_keywords, $linkcat_parentcat ) = $database -> dbrow( $query );
		$html -> makeheader( $words_links[ 'EDIT_CATEGORY' ] );
		$html -> deleteinit( $words_links[ 'ARE_YOU_SURE' ] );
		$html -> makesubheader();
		$html -> makegroupmenu( "links" );
		$html -> makeformheader( $words_links[ 'EDIT_CATEGORY' ], "edit", "editform", "post" );
		$websites = array();
		$query = $database -> dbquery( "SELECT preference_website, preference_value FROM " . DB_PREFIX . "esselbach_ct_preferences WHERE preference_key = 'WEBSITE_NAME'" );
		
		if( $database -> dbrows( $query ) )
		{
			echo "<strong>" . $words_links[ 'WEBSITE' ] . ":</strong> <select size=\"1\" name=\"input_category_website\">";
			echo "<option value=\"0\">" . $words_links[ 'ALL' ] . "</option>";
			
			while( list( $website_id, $website_name ) = $database -> dbrow( $query ) )
			{
				if( $website_id == $linkcat_website )
				{
					echo "<option selected=\"selected\" value=\"" . $website_id . "\">" . $website_name . "</option>";
				}
				else
				{
					echo "<option value=\"" . $website_id . "\">" . $website_name . "</option>";
				}
				
				$websites[ $website_id ] = $website_name;
			}
			
			echo "</select> ";
		}
		
		echo "<strong>" . $words_links[ 'PARENT_CATEGORY' ] . ":</strong><select size=\"1\" name=\"input_category_parent\">";
		echo "<option value=\"0\">" . $words_links[ 'NONE' ] . "</option>";
		$query = $database -> dbquery( "SELECT linkcat_id, linkcat_website, linkcat_name, linkcat_parentid FROM " . DB_PREFIX . "esselbach_ct_linkscats WHERE NOT(linkcat_id = '" . $linkcat_id . "') ORDER BY linkcat_position, linkcat_parentcat, linkcat_id" );
		
		while( list( $linkcat_pid, $linkcat_parentwebsite, $linkcat_parentname, $linkcat_parentid ) = $database -> dbrow( $query ) )
		{
			
			if( $linkcat_parentid > 1 )
			{
				$linkcat_parentname = str_repeat( "-", $linkcat_parentid ) . " " . $linkcat_parentname;
			}
			
			
			if( isset( $websites[ $linkcat_website ] ) )
			{
				$linkcat_parentwebsite = " (" . $websites[ $linkcat_parentwebsite ] . ")";
			}
			else
			{
				$linkcat_parentwebsite = "";
			}
			
			
			if( $linkcat_parentcat == $linkcat_pid )
			{
				echo "<option selected=\"selected\" value=\"" . $linkcat_pid . "\">" . $linkcat_parentname . $linkcat_parentwebsite . "</option>";
			}
			else
			{
				echo "<option value=\"" . $linkcat_pid . "\">" . $linkcat_parentname . $linkcat_parentwebsite . "</option>";
			}
		}
		
		echo "</select><br />";
		$html -> uppertext( $words_links[ 'CATEGORY_NAME' ], "input_category_name", $linkcat_name );
		$html -> uppertext( $words_links[ 'CATEGORY_DESCRIPTION' ], "input_category_description", $linkcat_description );
		$html -> uppertext( $words_links[ 'CATEGORY_KEYWORDS' ], "input_category_keywords", $linkcat_keywords );
		$html -> uppertext( $words_links[ 'CATEGORY_SEO_URL' ], "input_category_seo", $linkcat_seo );
		echo "<input type=\"hidden\" name=\"input_security_hash\" value=\"" . $options[ 2 ] . "\" /><input type=\"hidden\" name=\"aform\" value=\"doeditlinkscategory\" /><input type=\"hidden\" name=\"input_category_id\" value=\"" . $linkcat_id . "\" /><input type=\"submit\" value=\"" . $words_links[ 'SUBMIT' ] . "\" />";
		$query = $database -> dbquery( "SELECT linkcat_id, linkcat_name FROM " . DB_PREFIX . "esselbach_ct_linkscats WHERE linkcat_parentcat = '" . $options[ 1 ] . "' ORDER BY linkcat_position" );
		
		if( $database -> dbrows( $query ) )
		{
			$html -> tableheader( $words_links[ 'ID' ], $words_links[ 'SUBCATEGORY' ] );
			
			while( list( $linkcat_id, $linkcat_name ) = $database -> dbrow( $query ) )
			{
				$html -> tablemiddle( $linkcat_id, $linkcat_name, "linkscategories&amp;opts=editcat-" . $linkcat_id . "-" . $options[ 2 ], "linkscategories&amp;opts=deletecat-" . $linkcat_id . "-" . $options[ 2 ] );
			}
			
			$html -> maketablefooter();
		}
		
		$html -> makeformfooter();
	}

	if( $options[ 0 ] == "upcat" )
	{
		$query = $database -> dbquery( "SELECT linkcat_position FROM " . DB_PREFIX . "esselbach_ct_linkscats WHERE linkcat_id = '" . $options[ 1 ] . "'" );
		list( $position ) = $database -> dbrow( $query );
		
		if( $position == 1 )
		{
			$html -> login( $words_links[ 'EDIT_CATEGORY' ], $words_links[ 'CAT_ALREADY_TOP' ], "index.php?action=linkscategories" );
		}
		else
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_linkscats SET linkcat_position = linkcat_position - 1 WHERE linkcat_id = '" . $options[ 1 ] . "'" );
			$html -> login( $words_links[ 'EDIT_CATEGORY' ], $words_links[ 'CAT_INCREASED_PRIORITY' ], "index.php?action=linkscategories" );
		}
	}

	if( $options[ 0 ] == "downcat" )
	{
		$query = $database -> dbquery( "SELECT COUNT(linkcat_id) FROM " . DB_PREFIX . "esselbach_ct_linkscats" );
		list( $end_position ) = $database -> dbrow( $query );
		$query = $database -> dbquery( "SELECT linkcat_position FROM " . DB_PREFIX . "esselbach_ct_linkscats WHERE linkcat_id = '" . $options[ 1 ] . "'" );
		list( $current_position ) = $database -> dbrow( $query );
		
		if( $current_position == $end_position )
		{
			$html -> login( $words_links[ 'EDIT_CATEGORY' ], $words_links[ 'CAT_ALREADY_LAST' ], "index.php?action=linkscategories" );
		}
		else
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_linkscats SET linkcat_position = linkcat_position + 1 WHERE linkcat_id = '" . $options[ 1 ] . "'" );
			$html -> login( $words_links[ 'EDIT_CATEGORY' ], $words_links[ 'CAT_DECREASED_PRIORITY' ], "index.php?action=linkscategories" );
		}
	}

	if( !$options[ 0 ] )
	{
		
		$security_hash = $system -> adminhashput();
		
		$html -> makeheader( $words_links[ 'LINKS_CATEGORIES' ] );
		$html -> deleteinit( $words_links[ 'ARE_YOU_SURE' ] );
		$html -> makesubheader();
		$html -> makegroupmenu( 4 );
		$html -> makeformheader( $words_links[ 'LINKS_CATEGORIES' ], "categories", "doordercategories", "post" );
		$html -> tableheader( $words_links[ 'CATEGORY_SITEID' ], $words_links[ 'CATEGORY' ] );
		$query = $database -> dbquery( "SELECT linkcat_id, linkcat_website, linkcat_name, linkcat_parentid, linkcat_position FROM " . DB_PREFIX . "esselbach_ct_linkscats ORDER BY linkcat_position, linkcat_parentcat, linkcat_id" );
		
		while( list( $linkcat_id, $linkcat_website, $linkcat_name, $linkcat_parentid, $linkcat_position ) = $database -> dbrow( $query ) )
		{
			
			if( $linkcat_parentid > 1 )
			{
				$linkcat_name = str_repeat( "-", $linkcat_parentid ) . " " . $linkcat_name;
			}
			
			$html -> tablemiddle( $linkcat_id . " / " . $linkcat_website, $linkcat_name . " <a href=\"index.php?action=linkscategories&amp;opts=upcat-" . $linkcat_id . "-" . $security_hash . "\"><img src=\"../images/up.gif\" alt=\"up\" /></a> <a href=\"index.php?action=linkscategories&amp;opts=downcat-" . $linkcat_id . "-" . $security_hash . "\"><img src=\"../images/down.gif\" alt=\"down\" /></a> (" . $words_links[ 'PRIORITY' ] . ": <input name=\"input_priority[" . $linkcat_id . "]\" size=\"3\" value=\"" . $linkcat_position . "\" />)", "linkscategories&amp;opts=editcat-" . $linkcat_id . "-" . $security_hash, "linkscategories&amp;opts=deletecat-" . $linkcat_id . "-" . $security_hash );
		}
		
		$html -> table5col( "<input type=\"hidden\" name=\"input_security_hash\" value=\"" . $security_hash . "\" /><input type=\"hidden\" name=\"aform\" value=\"doupdatelinkscategories\" /><input type=\"submit\" value=\"" . $words_links[ 'UPDATE_PRIORITY' ] . "\" /><input type=\"submit\" name=\"input_doalphabetically\" value=\"" . $words_links[ 'ORDER_ALPHABETICALLY' ] . "\" /></form>" );
		
		$html -> maketablefooter();
		$html -> makeformsub( $words_links[ 'ADD_A_NEW_CATEGORY' ] );
		$websites = array();
		$query = $database -> dbquery( "SELECT preference_website, preference_value FROM " . DB_PREFIX . "esselbach_ct_preferences WHERE preference_key = 'WEBSITE_NAME'" );
		
		if( $database -> dbrows( $query ) )
		{
			echo "<strong>" . $words_links[ 'WEBSITE' ] . ":</strong> <select size=\"1\" name=\"input_category_website\">";
			echo "<option value=\"0\">" . $words_links[ 'ALL' ] . "</option>";
			
			while( list( $website_id, $website_name ) = $database -> dbrow( $query ) )
			{
				echo "<option value=\"" . $website_id . "\">" . $website_name . "</option>";
				$websites[ $website_id ] = $website_name;
			}
			
			echo "</select><br />";
		}
		
		$html -> makeeoption( $words_links[ 'CATEGORY_NAME' ], "input_category_name", "" );
		$html -> makeeoption( $words_links[ 'CATEGORY_DESCRIPTION' ], "input_category_description", "" );
		$html -> makeeoption( $words_links[ 'CATEGORY_KEYWORDS' ], "input_category_keywords", "" );
		$html -> makeeoption( $words_links[ 'CATEGORY_SEO_URL' ], "input_category_seo", "" );
		echo "<strong>" . $words_links[ 'PARENT_CATEGORY' ] . ":</strong><br /><select size=\"1\" name=\"input_category_parent\">";
		echo "<option value=\"0\">" . $words_links[ 'NONE' ] . "</option>";
		$query = $database -> dbquery( "SELECT linkcat_id, linkcat_website, linkcat_name, linkcat_parentid FROM " . DB_PREFIX . "esselbach_ct_linkscats ORDER BY linkcat_position, linkcat_parentcat, linkcat_id" );
		
		while( list( $linkcat_id, $linkcat_website, $linkcat_name, $linkcat_parentid ) = $database -> dbrow( $query ) )
		{
			
			if( $linkcat_parentid > 1 )
			{
				$linkcat_name = str_repeat( "-", $linkcat_parentid ) . " " . $linkcat_name;
			}
			
			
			if( isset( $websites[ $linkcat_website ] ) )
			{
				$linkcat_website = " (" . $websites[ $linkcat_website ] . ")";
			}
			else
			{
				$linkcat_website = "";
			}
			
			echo "<option value=\"" . $linkcat_id . "\">" . $linkcat_name . $linkcat_website . "</option>";
		}
		
		echo "</select>";
		echo "<br /><input type=\"hidden\" name=\"input_security_hash\" value=\"" . $security_hash . "\" /><input type=\"hidden\" name=\"aform\" value=\"doaddlinkscategory\" /><input type=\"submit\" value=\"" . $words_links[ 'SUBMIT' ] . "\" />";
		$html -> makeformfooter();
	}
}
?>