<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.0                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 529     Patch: 11                                                 |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Mailinglists
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function AdminListsCategories
 * A function to manage mailing list categories 
 * @author Philipp Louis Esselbach
 */
function AdminListsCategories( $opts )
{
	global $database, $system, $security, $preferences, $html, $words_mailinglists;
	$options = explode( "-", $opts );
	$options[ 0 ] = ( isset( $options[ 0 ] ) ) ? $security -> checkvar( $options[ 0 ] ) : "" ;
	$options[ 1 ] = ( isset( $options[ 1 ] ) ) ? $security -> checknum( $options[ 1 ] ) : "" ;
	$options[ 2 ] = ( isset( $options[ 2 ] ) ) ? $security -> checkvar( $options[ 2 ] ) : "" ;
	
	if( $options[ 0 ] )
	{
		if( ( $system -> adminhashget() != $options[ 2 ] ) and( $preferences[ 'website_subsessions_admin' ] ) )
		{
			$html -> login( $words_mailinglists[ 'ERROR' ], $words_mailinglists[ 'INVALID_SESSION' ], "index.php" );
			exit;
		}
	}

	if( $options[ 0 ] == "deletecat" )
	{
		$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_mailinglistscats WHERE mailinglistcat_id='" . $options[ 1 ] . "'" );
		$html -> login( $words_mailinglists[ 'EDIT_CATEGORY' ], $words_mailinglists[ 'CATEGORY_REMOVED' ], "index.php?action=listscategories" );
	}

	if( $options[ 0 ] == "editcat" )
	{
		$query = $database -> dbquery( "SELECT mailinglistcat_id, mailinglistcat_website, mailinglistcat_name, mailinglistcat_seo, mailinglistcat_description, mailinglistcat_keywords FROM " . DB_PREFIX . "esselbach_ct_mailinglistscats WHERE mailinglistcat_id = '" . $options[ 1 ] . "'" );
		list( $mailinglistcat_id, $mailinglistcat_website, $mailinglistcat_name, $mailinglistcat_seo, $mailinglistcat_description, $mailinglistcat_keywords ) = $database -> dbrow( $query );
		$html -> makeheader( $words_mailinglists[ 'EDIT_CATEGORY' ] );
		$html -> deleteinit( $words_mailinglists[ 'ARE_YOU_SURE' ] );
		$html -> makesubheader();
		$html -> makegroupmenu( "mailinglists" );
		$html -> makeformheader( $words_mailinglists[ 'EDIT_CATEGORY' ], "edit", "editform", "post" );
		$query = $database -> dbquery( "SELECT preference_website, preference_value FROM " . DB_PREFIX . "esselbach_ct_preferences WHERE preference_key = 'WEBSITE_NAME'" );
		
		if( $database -> dbrows( $query ) )
		{
			echo "<strong>" . $words_mailinglists[ 'WEBSITE' ] . ":</strong> <select size=\"1\" name=\"input_category_website\">";
			echo "<option value=\"0\">" . $words_mailinglists[ 'ALL' ] . "</option>";
			
			while( list( $website_id, $website_name ) = $database -> dbrow( $query ) )
			{
				if( $website_id == $mailinglistcat_website )
				{
					echo "<option selected=\"selected\" value=\"" . $website_id . "\">" . $website_name . "</option>";
				}
				else
				{
					echo "<option value=\"" . $website_id . "\">" . $website_name . "</option>";
				}
			}
			
			echo "</select><br />";
		}
		
		$html -> uppertext( $words_mailinglists[ 'CATEGORY_NAME' ], "input_category_name", $mailinglistcat_name );
		$html -> uppertext( $words_mailinglists[ 'CATEGORY_DESCRIPTION' ], "input_category_description", $mailinglistcat_description );
		$html -> uppertext( $words_mailinglists[ 'CATEGORY_KEYWORDS' ], "input_category_keywords", $mailinglistcat_keywords );
		$html -> uppertext( $words_mailinglists[ 'CATEGORY_SEO_URL' ], "input_category_seo", $mailinglistcat_seo );
		echo "<input type=\"hidden\" name=\"input_security_hash\" value=\"" . $security_hash . "\" /><input type=\"hidden\" name=\"aform\" value=\"doeditlistscategory\" /><input type=\"hidden\" name=\"input_category_id\" value=\"" . $mailinglistcat_id . "\" /><input type=\"submit\" value=\"" . $words_mailinglists[ 'SUBMIT' ] . "\" />";
		$query = $database -> dbquery( "SELECT mailinglistcat_id, mailinglistcat_name FROM " . DB_PREFIX . "esselbach_ct_mailinglistscats WHERE mailinglistcat_parentcat = '" . $options[ 1 ] . "' ORDER BY mailinglistcat_position" );
		
		if( $database -> dbrows( $query ) )
		{
			$html -> tableheader( $words_mailinglists[ 'ID' ], $words_mailinglists[ 'SUBCATEGORY' ] );
			
			while( list( $mailinglistcat_id, $mailinglistcat_name ) = $database -> dbrow( $query ) )
			{
				$html -> tablemiddle( $mailinglistcat_id, $mailinglistcat_name, "listscategories&amp;opts=editcat-" . $mailinglistcat_id . "-" . $options[ 2 ], "listscategories&amp;opts=deletecat-" . $mailinglistcat_id . "-" . $options[ 2 ] );
			}
			
			$html -> maketablefooter();
		}
		
		$html -> makeformfooter();
	}

	if( $options[ 0 ] == "upcat" )
	{
		$query = $database -> dbquery( "SELECT mailinglistcat_position FROM " . DB_PREFIX . "esselbach_ct_mailinglistscats WHERE mailinglistcat_id = '" . $options[ 1 ] . "'" );
		list( $position ) = $database -> dbrow( $query );
		
		if( $position == 1 )
		{
			$html -> login( $words_mailinglists[ 'EDIT_CATEGORY' ], $words_mailinglists[ 'CAT_ALREADY_TOP' ], "index.php?action=listscategories" );
		}
		else
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_mailinglistscats SET mailinglistcat_position = mailinglistcat_position - 1 WHERE mailinglistcat_id = '" . $options[ 1 ] . "'" );
			$html -> login( $words_mailinglists[ 'EDIT_CATEGORY' ], $words_mailinglists[ 'CAT_INCREASED_PRIORITY' ], "index.php?action=listscategories" );
		}
	}

	if( $options[ 0 ] == "downcat" )
	{
		$query = $database -> dbquery( "SELECT COUNT(mailinglistcat_id) FROM " . DB_PREFIX . "esselbach_ct_mailinglistscats" );
		list( $end_position ) = $database -> dbrow( $query );
		$query = $database -> dbquery( "SELECT mailinglistcat_position FROM " . DB_PREFIX . "esselbach_ct_mailinglistscats WHERE mailinglistcat_id = '" . $options[ 1 ] . "'" );
		list( $current_position ) = $database -> dbrow( $query );
		
		if( $current_position == $end_position )
		{
			$html -> login( $words_mailinglists[ 'EDIT_CATEGORY' ], $words_mailinglists[ 'CAT_ALREADY_LAST' ], "index.php?action=listscategories" );
		}
		else
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_mailinglistscats SET mailinglistcat_position = mailinglistcat_position + 1 WHERE mailinglistcat_id = '" . $options[ 1 ] . "'" );
			$html -> login( $words_mailinglists[ 'EDIT_CATEGORY' ], $words_mailinglists[ 'CAT_DECREASED_PRIORITY' ], "index.php?action=listscategories" );
		}
	}

	if( !$options[ 0 ] )
	{
		
		$security_hash = $system -> adminhashput();
		
		$html -> makeheader( $words_mailinglists[ 'MAILING_LISTS_CATEGORIES' ] );
		$html -> deleteinit( $words_mailinglists[ 'ARE_YOU_SURE' ] );
		$html -> makesubheader();
		$html -> makegroupmenu( 2 );
		$html -> makeformheader( $words_mailinglists[ 'MAILING_LISTS_CATEGORIES' ], "categories", "doordercategories", "post" );
		$html -> tableheader( $words_mailinglists[ 'CATEGORY_SITEID' ], $words_mailinglists[ 'CATEGORY' ] );
		$query = $database -> dbquery( "SELECT mailinglistcat_id, mailinglistcat_website, mailinglistcat_name, mailinglistcat_parentid, mailinglistcat_position FROM " . DB_PREFIX . "esselbach_ct_mailinglistscats ORDER BY mailinglistcat_position, mailinglistcat_parentcat, mailinglistcat_id" );
		
		while( list( $mailinglistcat_id, $mailinglistcat_website, $mailinglistcat_name, $mailinglistcat_parentid, $mailinglistcat_position ) = $database -> dbrow( $query ) )
		{
			
			if( $mailinglistcat_parentid > 1 )
			{
				$mailinglistcat_name = str_repeat( "-", $mailinglistcat_parentid ) . " " . $mailinglistcat_name;
			}
			
			$html -> tablemiddle( $mailinglistcat_id . " / " . $mailinglistcat_website, $mailinglistcat_name . " <a href=\"index.php?action=listscategories&amp;opts=upcat-" . $mailinglistcat_id . "-" . $security_hash . "\"><img src=\"../images/up.gif\" alt=\"up\" /></a> <a href=\"index.php?action=listscategories&amp;opts=downcat-" . $mailinglistcat_id . "-" . $security_hash . "\"><img src=\"../images/down.gif\" alt=\"down\" /></a> (" . $words_mailinglists[ 'PRIORITY' ] . ": <input name=\"input_priority[" . $mailinglistcat_id . "]\" size=\"3\" value=\"" . $mailinglistcat_position . "\" />)", "listscategories&amp;opts=editcat-" . $mailinglistcat_id . "-" . $security_hash, "listscategories&amp;opts=deletecat-" . $mailinglistcat_id . "-" . $security_hash );
		}

		$html -> table5col( "<input type=\"hidden\" name=\"input_security_hash\" value=\"" . $security_hash . "\" /><input type=\"hidden\" name=\"aform\" value=\"doupdatelistscategories\" /><input type=\"submit\" value=\"" . $words_mailinglists[ 'UPDATE_PRIORITY' ] . "\" /><input type=\"submit\" name=\"input_doalphabetically\" value=\"" . $words_mailinglists[ 'ORDER_ALPHABETICALLY' ] . "\" /></form>" );
		
		$html -> maketablefooter();
		$html -> makeformsub( $words_mailinglists[ 'ADD_A_NEW_CATEGORY' ] );
		$websites = array();
		$query = $database -> dbquery( "SELECT preference_website, preference_value FROM " . DB_PREFIX . "esselbach_ct_preferences WHERE preference_key = 'WEBSITE_NAME'" );
		
		if( $database -> dbrows( $query ) )
		{
			echo "<strong>" . $words_mailinglists[ 'WEBSITE' ] . ":</strong> <select size=\"1\" name=\"input_category_website\">";
			echo "<option value=\"0\">" . $words_mailinglists[ 'ALL' ] . "</option>";
			
			while( list( $website_id, $website_name ) = $database -> dbrow( $query ) )
			{
				echo "<option value=\"" . $website_id . "\">" . $website_name . "</option>";
				$websites[ $website_id ] = $website_name;
			}
			
			echo "</select><br />";
		}
		
		$html -> makeeoption( $words_mailinglists[ 'CATEGORY_NAME' ], "input_category_name", "" );
		$html -> makeeoption( $words_mailinglists[ 'CATEGORY_DESCRIPTION' ], "input_category_description", "" );
		$html -> makeeoption( $words_mailinglists[ 'CATEGORY_KEYWORDS' ], "input_category_keywords", "" );
		$html -> makeeoption( $words_mailinglists[ 'CATEGORY_SEO_URL' ], "input_category_seo", "" );
		echo "<strong>" . $words_mailinglists[ 'PARENT_CATEGORY' ] . ":</strong><br /><select size=\"1\" name=\"input_category_parent\">";
		echo "<option value=\"0\">" . $words_mailinglists[ 'NONE' ] . "</option>";
		$query = $database -> dbquery( "SELECT mailinglistcat_id, mailinglistcat_website, mailinglistcat_name, mailinglistcat_parentid FROM " . DB_PREFIX . "esselbach_ct_mailinglistscats ORDER BY mailinglistcat_position, mailinglistcat_id" );
		
		while( list( $mailinglistcat_id, $mailinglistcat_website, $mailinglistcat_name, $mailinglistcat_parentid ) = $database -> dbrow( $query ) )
		{
			
			if( $mailinglistcat_parentid > 1 )
			{
				$mailinglistcat_name = str_repeat( "-", $mailinglistcat_parentid ) . " " . $mailinglistcat_name;
			}
			
			
			if( isset( $websites[ $mailinglistcat_website ] ) )
			{
				$mailinglistcat_website = " (" . $websites[ $mailinglistcat_website ] . ")";
			}
			else
			{
				$mailinglistcat_website = "";
			}
			
			echo "<option value=\"" . $mailinglistcat_id . "\">" . $mailinglistcat_name . $mailinglistcat_website . "</option>";
		}
		
		echo "</select>";
		echo "<br /><input type=\"hidden\" name=\"input_security_hash\" value=\"" . $security_hash . "\" /><input type=\"hidden\" name=\"aform\" value=\"doaddlistscategory\" /><input type=\"submit\" value=\"" . $words_mailinglists[ 'SUBMIT' ] . "\" />";
		$html -> makeformfooter();
	}
}
?>