<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.0                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 529     Patch: 11                                                 |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage News
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function AdminNewsChannel
 * A function to manage news channels 
 * @author Philipp Louis Esselbach
 */
function AdminNewsChannels( $opts )
{
	global $database, $system, $security, $preferences, $html, $words_news;
	$options = explode( "-", $opts );
	$options[ 0 ] = ( isset( $options[ 0 ] ) ) ? $security -> checkvar( $options[ 0 ] ) : "" ;
	$options[ 1 ] = ( isset( $options[ 1 ] ) ) ? $security -> checknum( $options[ 1 ] ) : "" ;
	$options[ 2 ] = ( isset( $options[ 2 ] ) ) ? $security -> checkvar( $options[ 2 ] ) : "" ;
	
	if( $options[ 0 ] )
	{
		if( ( $system -> adminhashget() != $options[ 2 ] ) and( $preferences[ 'website_subsessions_admin' ] ) )
		{
			$html -> login( $words_news[ 'ERROR' ], $words_news[ 'INVALID_SESSION' ], "index.php" );
			exit;
		}
	}

	if( $options[ 0 ] == "deletechannel" )
	{
		$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_newschannels WHERE newschannel_id = '" . $options[ 1 ] . "'" );
		$html -> login( $words_news[ 'EDIT_CHANNEL' ], $words_news[ 'CHANNEL_REMOVED' ], "index.php?action=newschannels" );
	}

	if( $options[ 0 ] == "editchannel" )
	{
		$query = $database -> dbquery( "SELECT newschannel_id, newschannel_website, newschannel_name, newschannel_seo, newschannel_description, newschannel_keywords, newschannel_parentcat FROM " . DB_PREFIX . "esselbach_ct_newschannels WHERE newschannel_id = '" . $options[ 1 ] . "'" );
		list( $newschannel_id, $newschannel_website, $newschannel_name, $newschannel_seo, $newschannel_description, $newschannel_keywords, $newschannel_parentcat ) = $database -> dbrow( $query );
		$html -> makeheader( $words_news[ 'EDIT_CHANNEL' ] );
		$html -> deleteinit( $words_news[ 'ARE_YOU_SURE' ] );
		$html -> makesubheader();
		$html -> makegroupmenu( "news" );
		$html -> makeformheader( $words_news[ 'EDIT_CHANNEL' ], "edit", "editform", "post" );
		$query = $database -> dbquery( "SELECT preference_website, preference_value FROM " . DB_PREFIX . "esselbach_ct_preferences WHERE preference_key = 'WEBSITE_NAME'" );
		
		if( $database -> dbrows( $query ) )
		{
			echo "<strong>" . $words_news[ 'WEBSITE' ] . ":</strong> <select size=\"1\" name=\"input_channel_website\">";
			echo "<option value=\"0\">" . $words_news[ 'ALL' ] . "</option>";
			
			while( list( $website_id, $website_name ) = $database -> dbrow( $query ) )
			{
				if( $website_id == $newschannel_website )
				{
					echo "<option selected=\"selected\" value=\"" . $website_id . "\">" . $website_name . "</option>";
				}
				else
				{
					echo "<option value=\"" . $website_id . "\">" . $website_name . "</option>";
				}
			}
			
			echo "</select> ";
		}
		
		echo "<strong>" . $words_news[ 'PARENT_CHANNEL' ] . ":</strong> <select size=\"1\" name=\"input_channel_parent\">";
		echo "<option value=\"0\">" . $words_news[ 'NONE' ] . "</option>";
		$query = $database -> dbquery( "SELECT newschannel_id, newschannel_name, newschannel_parentid FROM " . DB_PREFIX . "esselbach_ct_newschannels WHERE NOT(newschannel_id = '" . $newschannel_id . "') ORDER BY newschannel_position, newschannel_parentcat, newschannel_id" );
		
		while( list( $newschannel_pid, $newschannel_parentname, $newschannel_parentid ) = $database -> dbrow( $query ) )
		{
			
			if( $newschannel_parentid > 1 )
			{
				$newschannel_parentname = str_repeat( "-", $newschannel_parentid ) . " " . $newschannel_parentname;
			}
			
			if( $newschannel_parentcat == $newschannel_pid )
			{
				echo "<option selected=\"selected\" value=\"" . $newschannel_pid . "\">" . $newschannel_parentname . "</option>";
			}
			else
			{
				echo "<option value=\"" . $newschannel_pid . "\">" . $newschannel_parentname . "</option>";
			}
		}
		
		echo "</select><br />";
		$html -> uppertext( $words_news[ 'CHANNEL_NAME' ], "input_channel_name", $newschannel_name );
		$html -> uppertext( $words_news[ 'CHANNEL_DESCRIPTION' ], "input_channel_description", $newschannel_description );
		$html -> uppertext( $words_news[ 'CHANNEL_KEYWORDS' ], "input_channel_keywords", $newschannel_keywords );
		$html -> uppertext( $words_news[ 'CHANNEL_SEO_URL' ], "input_channel_seo", $newschannel_seo );
		echo "<input type=\"hidden\" name=\"input_security_hash\" value=\"" . $options[ 2 ] . "\" /><input type=\"hidden\" name=\"aform\" value=\"doeditnewschannel\" /><input type=\"hidden\" name=\"input_channel_id\" value=\"" . $newschannel_id . "\" /><input type=\"submit\" value=\"" . $words_news[ 'SUBMIT' ] . "\" />";
		$query = $database -> dbquery( "SELECT newschannel_id, newschannel_name FROM " . DB_PREFIX . "esselbach_ct_newschannels WHERE newschannel_parentcat = '" . $options[ 1 ] . "' ORDER BY newschannel_position" );
		
		if( $database -> dbrows( $query ) )
		{
			$html -> tableheader( $words_news[ 'ID' ], $words_news[ 'SUBCHANNEL' ] );
			
			while( list( $newschannel_id, $newschannel_name ) = $database -> dbrow( $query ) )
			{
				$html -> tablemiddle( $newschannel_id, $newschannel_name, "newschannels&amp;opts=editchannel-" . $newschannel_id . "-" . $options[ 2 ], "newschannels&amp;opts=deletechannel-" . $newschannel_id . "-" . $options[ 2 ] );
			}
			
			$html -> maketablefooter();
		}
		
		$html -> makeformfooter();
	}

	if( $options[ 0 ] == "upchannel" )
	{
		$query = $database -> dbquery( "SELECT newschannel_position FROM " . DB_PREFIX . "esselbach_ct_newschannels WHERE newschannel_id = '" . $options[ 1 ] . "'" );
		list( $position ) = $database -> dbrow( $query );
		
		if( $position == 1 )
		{
			$html -> login( $words_news[ 'EDIT_CHANNEL' ], $words_news[ 'CHANNEL_ALREADY_TOP' ], "index.php?action=newschannels" );
		}
		else
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_newschannels SET newschannel_position = newschannel_position - 1 WHERE newschannel_id = '" . $options[ 1 ] . "'" );
			$html -> login( $words_news[ 'EDIT_CHANNEL' ], $words_news[ 'CHANNEL_INCREASED_PRIORITY' ], "index.php?action=newschannels" );
		}
	}

	if( $options[ 0 ] == "downchannel" )
	{
		$query = $database -> dbquery( "SELECT count(newschannel_id) FROM " . DB_PREFIX . "esselbach_ct_newschannels" );
		list( $end_position ) = $database -> dbrow( $query );
		$query = $database -> dbquery( "SELECT newschannel_position FROM " . DB_PREFIX . "esselbach_ct_newschannels WHERE newschannel_id = '" . $options[ 1 ] . "'" );
		list( $current_position ) = $database -> dbrow( $query );
		
		if( $current_position == $end_position )
		{
			$html -> login( $words_news[ 'EDIT_CHANNEL' ], $words_news[ 'CHANNEL_ALREADY_LAST' ], "index.php?action=newschannels" );
		}
		else
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_newschannels SET newschannel_position = newschannel_position + 1 WHERE newschannel_id = '" . $options[ 1 ] . "'" );
			$html -> login( $words_news[ 'EDIT_CHANNEL' ], $words_news[ 'CHANNEL_DECREASED_PRIORITY' ], "index.php?action=newschannels" );
		}
	}

	if( !$options[ 0 ] )
	{
		
		$security_hash = $system -> adminhashput();
		
		$html -> makeheader( $words_news[ 'NEWS_CHANNELS' ] );
		$html -> deleteinit( $words_news[ 'ARE_YOU_SURE' ] );
		$html -> makesubheader();
		$html -> makegroupmenu( "news" );
		$html -> makeformheader( $words_news[ 'NEWS_CHANNELS' ], "channels", "doorderchannels", "post" );
		$html -> tableheader( $words_news[ 'ID' ], $words_news[ 'CHANNEL' ] );
		$query = $database -> dbquery( "SELECT newschannel_id, newschannel_name, newschannel_parentid, newschannel_position FROM " . DB_PREFIX . "esselbach_ct_newschannels ORDER BY newschannel_position, newschannel_parentcat, newschannel_id" );
		
		while( list( $newschannel_id, $newschannel_name, $newschannel_parentid, $newschannel_position ) = $database -> dbrow( $query ) )
		{
			
			if( $newschannel_parentid > 1 )
			{
				$newschannel_name = str_repeat( "-", $newschannel_parentid ) . " " . $newschannel_name;
			}
			
			$html -> tablemiddle( $newschannel_id, $newschannel_name . " <a href=\"index.php?action=newschannels&amp;opts=upchannel-" . $newschannel_id . "-" . $security_hash . "\"><img src=\"../images/up.gif\" alt=\"up\" /></a> <a href=\"index.php?action=newschannels&amp;opts=downchannel-" . $newschannel_id . "-" . $security_hash . "\"><img src=\"../images/down.gif\" alt=\"down\" /></a> (" . $words_news[ 'PRIORITY' ] . ": <input name=\"input_priority[" . $newschannel_id . "]\" size=\"3\" value=\"" . $newschannel_position . "\" />)", "newschannels&amp;opts=editchannel-" . $newschannel_id . "-" . $security_hash, "newschannels&amp;opts=deletechannel-" . $newschannel_id . "-" . $security_hash );
		}
		$html -> table5col( "<input type=\"hidden\" name=\"input_security_hash\" value=\"" . $security_hash . "\" /><input type=\"hidden\" name=\"aform\" value=\"doupdatenewschannels\" /><input type=\"submit\" value=\"" . $words_news[ 'UPDATE_PRIORITY' ] . "\" /><input type=\"submit\" name=\"input_doalphabetically\" value=\"" . $words_news[ 'ORDER_ALPHABETICALLY' ] . "\" /></form>" );
		
		$html -> maketablefooter();
		$html -> makeformsub( $words_news[ 'ADD_A_NEW_CHANNEL' ] );
		$query = $database -> dbquery( "SELECT preference_website, preference_value FROM " . DB_PREFIX . "esselbach_ct_preferences WHERE preference_key = 'WEBSITE_NAME'" );
		
		if( $database -> dbrows( $query ) )
		{
			echo "<strong>" . $words_news[ 'WEBSITE' ] . ":</strong> <select size=\"1\" name=\"input_channel_website\">";
			echo "<option value=\"0\">" . $words_news[ 'ALL' ] . "</option>";
			
			while( list( $website_id, $website_name ) = $database -> dbrow( $query ) )
			{
				echo "<option value=\"" . $website_id . "\">" . $website_name . "</option>";
			}
			
			echo "</select><br />";
		}
		
		$html -> makeeoption( $words_news[ 'CHANNEL_NAME' ], "input_channel_name", "" );
		$html -> makeeoption( $words_news[ 'CHANNEL_DESCRIPTION' ], "input_channel_description", "" );
		$html -> makeeoption( $words_news[ 'CHANNEL_KEYWORDS' ], "input_channel_keywords", "" );
		$html -> makeeoption( $words_news[ 'CHANNEL_SEO_URL' ], "input_channel_seo", "" );
		echo "<strong>" . $words_news[ 'PARENT_CHANNEL' ] . ":</strong><br /><select size=\"1\" name=\"input_channel_parent\">";
		echo "<option value=\"0\">" . $words_news[ 'NONE' ] . "</option>";
		$query = $database -> dbquery( "SELECT newschannel_id, newschannel_name, newschannel_parentid FROM " . DB_PREFIX . "esselbach_ct_newschannels ORDER BY newschannel_position, newschannel_parentcat, newschannel_id" );
		
		while( list( $newschannel_id, $newschannel_name, $newschannel_parentid ) = $database -> dbrow( $query ) )
		{
			
			if( $newschannel_parentid > 1 )
			{
				$newschannel_name = str_repeat( "-", $newschannel_parentid ) . " " . $newschannel_name;
			}
			
			echo "<option value=\"" . $newschannel_id . "\">" . $newschannel_name . "</option>";
		}
		
		echo "</select>";
		echo "<br /><input type=\"hidden\" name=\"input_security_hash\" value=\"" . $security_hash . "\" /><input type=\"hidden\" name=\"aform\" value=\"doaddnewschannel\" /><input type=\"submit\" value=\"" . $words_news[ 'SUBMIT' ] . "\" />";
		$html -> makeformfooter();
	}
}
?>