<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.0                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 529     Patch: 11                                                 |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Tickets
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function AdminTicketsCategories
 * A function to manage trouble tickets categories 
 * @author Philipp Louis Esselbach
 */
function AdminTicketsCategories( $opts )
{
	global $database, $system, $security, $preferences, $html, $words_tickets;
	$options = explode( "-", $opts );
	$options[ 0 ] = ( isset( $options[ 0 ] ) ) ? $security -> checkvar( $options[ 0 ] ) : "" ;
	$options[ 1 ] = ( isset( $options[ 1 ] ) ) ? $security -> checknum( $options[ 1 ] ) : "" ;
	$options[ 2 ] = ( isset( $options[ 2 ] ) ) ? $security -> checkvar( $options[ 2 ] ) : "" ;
	
	if( $options[ 0 ] )
	{
		if( ( $system -> adminhashget() != $options[ 2 ] ) and( $preferences[ 'website_subsessions_admin' ] ) )
		{
			$html -> login( $words_tickets[ 'ERROR' ], $words_tickets[ 'INVALID_SESSION' ], "index.php" );
			exit;
		}
	}

	if( $options[ 0 ] == "deletecat" )
	{
		$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_ticketscats WHERE ticketcat_id='" . $options[ 1 ] . "'" );
		$html -> login( $words_tickets[ 'EDIT_CATEGORY' ], $words_tickets[ 'CATEGORY_REMOVED' ], "index.php?action=ticketscategories" );
	}

	if( $options[ 0 ] == "editcat" )
	{
		$query = $database -> dbquery( "SELECT ticketcat_id, ticketcat_website, ticketcat_name FROM " . DB_PREFIX . "esselbach_ct_ticketscats WHERE ticketcat_id = '" . $options[ 1 ] . "'" );
		list( $ticketcat_id, $ticketcat_website, $ticketcat_name ) = $database -> dbrow( $query );
		$html -> makeheader( $words_tickets[ 'EDIT_CATEGORY' ] );
		$html -> deleteinit( $words_tickets[ 'ARE_YOU_SURE' ] );
		$html -> makesubheader();
		$html -> makegroupmenu( "tickets" );
		$html -> makeformheader( $words_tickets[ 'EDIT_CATEGORY' ], "edit", "editform", "post" );
		$query = $database -> dbquery( "SELECT preference_website, preference_value FROM " . DB_PREFIX . "esselbach_ct_preferences WHERE preference_key = 'WEBSITE_NAME'" );
		
		if( $database -> dbrows( $query ) )
		{
			echo "<strong>" . $words_tickets[ 'WEBSITE' ] . ":</strong> <select size=\"1\" name=\"input_category_website\">";
			echo "<option value=\"0\">" . $words_tickets[ 'ALL' ] . "</option>";
			
			while( list( $website_id, $website_name ) = $database -> dbrow( $query ) )
			{
				if( $website_id == $ticketcat_website )
				{
					echo "<option selected=\"selected\" value=\"" . $website_id . "\">" . $website_name . "</option>";
				}
				else
				{
					echo "<option value=\"" . $website_id . "\">" . $website_name . "</option>";
				}
			}
			
			echo "</select><br />";
		}
		
		$html -> uppertext( $words_tickets[ 'CATEGORY_NAME' ], "input_category_name", $ticketcat_name );
		echo "<input type=\"hidden\" name=\"input_security_hash\" value=\"" . $options[ 2 ] . "\" /><input type=\"hidden\" name=\"aform\" value=\"doeditticketscategory\" /><input type=\"hidden\" name=\"input_category_id\" value=\"" . $ticketcat_id . "\" /><input type=\"submit\" value=\"" . $words_tickets[ 'SUBMIT' ] . "\" />";
		$query = $database -> dbquery( "SELECT ticketcat_id, ticketcat_name FROM " . DB_PREFIX . "esselbach_ct_ticketscats WHERE ticketcat_parentcat = '" . $options[ 1 ] . "' ORDER BY ticketcat_position" );
		
		if( $database -> dbrows( $query ) )
		{
			$html -> tableheader( $words_tickets[ 'ID' ], $words_tickets[ 'SUBCATEGORY' ] );
			
			while( list( $ticketcat_id, $ticketcat_name ) = $database -> dbrow( $query ) )
			{
				$html -> tablemiddle( $ticketcat_id, $ticketcat_name, "ticketscategories&amp;opts=editcat-" . $ticketcat_id . "-" . $options[ 2 ], "ticketscategories&amp;opts=deletecat-" . $ticketcat_id . "-" . $options[ 2 ] );
			}
			
			$html -> maketablefooter();
		}
		
		$html -> makeformfooter();
	}

	if( $options[ 0 ] == "upcat" )
	{
		$query = $database -> dbquery( "SELECT ticketcat_position FROM " . DB_PREFIX . "esselbach_ct_ticketscats WHERE ticketcat_id = '" . $options[ 1 ] . "'" );
		list( $position ) = $database -> dbrow( $query );
		
		if( $position == 1 )
		{
			$html -> login( $words_tickets[ 'EDIT_CATEGORY' ], $words_tickets[ 'CAT_ALREADY_TOP' ], "index.php?action=ticketscategories" );
		}
		else
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_ticketscats SET ticketcat_position = ticketcat_position - 1 WHERE ticketcat_id = '" . $options[ 1 ] . "'" );
			$html -> login( $words_tickets[ 'EDIT_CATEGORY' ], $words_tickets[ 'CAT_INCREASED_PRIORITY' ], "index.php?action=ticketscategories" );
		}
	}

	if( $options[ 0 ] == "downcat" )
	{
		$query = $database -> dbquery( "SELECT COUNT(ticketcat_id) FROM " . DB_PREFIX . "esselbach_ct_ticketscats" );
		list( $end_position ) = $database -> dbrow( $query );
		$query = $database -> dbquery( "SELECT ticketcat_position FROM " . DB_PREFIX . "esselbach_ct_ticketscats WHERE ticketcat_id = '" . $options[ 1 ] . "'" );
		list( $current_position ) = $database -> dbrow( $query );
		
		if( $current_position == $end_position )
		{
			$html -> login( $words_tickets[ 'EDIT_CATEGORY' ], $words_tickets[ 'CAT_ALREADY_LAST' ], "index.php?action=ticketscategories" );
		}
		else
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_ticketscats SET ticketcat_position = ticketcat_position + 1 WHERE ticketcat_id = '" . $options[ 1 ] . "'" );
			$html -> login( $words_tickets[ 'EDIT_CATEGORY' ], $words_tickets[ 'CAT_DECREASED_PRIORITY' ], "index.php?action=ticketscategories" );
		}
	}

	if( !$options[ 0 ] )
	{
		
		$security_hash = $system -> adminhashput();
		
		$html -> makeheader( $words_tickets[ 'TICKETS_CATEGORIES' ] );
		$html -> deleteinit( $words_tickets[ 'ARE_YOU_SURE' ] );
		$html -> makesubheader();
		$html -> makegroupmenu( "tickets" );
		$html -> makeformheader( $words_tickets[ 'TICKETS_CATEGORIES' ], "categories", "doordercategories", "post" );
		$html -> tableheader( $words_tickets[ 'CATEGORY_SITEID' ], $words_tickets[ 'CATEGORY' ] );
		$query = $database -> dbquery( "SELECT ticketcat_id, ticketcat_website, ticketcat_name, ticketcat_parentid, ticketcat_position FROM " . DB_PREFIX . "esselbach_ct_ticketscats ORDER BY ticketcat_position, ticketcat_parentcat, ticketcat_id" );
		
		while( list( $ticketcat_id, $ticketcat_website, $ticketcat_name, $ticketcat_parentid, $ticketcat_position ) = $database -> dbrow( $query ) )
		{
			
			if( $ticketcat_parentid > 1 )
			{
				$ticketcat_name = str_repeat( "-", $ticketcat_parentid ) . " " . $ticketcat_name;
			}
			
			$html -> tablemiddle( $ticketcat_id . " / " . $ticketcat_website, $ticketcat_name . " <a href=\"index.php?action=ticketscategories&amp;opts=upcat-" . $ticketcat_id . "-" . $security_hash . "\"><img src=\"../images/up.gif\" alt=\"up\" /></a> <a href=\"index.php?action=ticketscategories&amp;opts=downcat-" . $ticketcat_id . "-" . $security_hash . "\"><img src=\"../images/down.gif\" alt=\"down\" /></a> (" . $words_tickets[ 'PRIORITY' ] . ": <input name=\"input_priority[" . $ticketcat_id . "]\" size=\"3\" value=\"" . $ticketcat_position . "\" />)", "ticketscategories&amp;opts=editcat-" . $ticketcat_id . "-" . $security_hash, "ticketscategories&amp;opts=deletecat-" . $ticketcat_id . "-" . $security_hash );
		}
		
		$html -> table5col( "<input type=\"hidden\" name=\"input_security_hash\" value=\"" . $security_hash . "\" /><input type=\"hidden\" name=\"aform\" value=\"doupdateticketscategories\" /><input type=\"submit\" value=\"" . $words_tickets[ 'UPDATE_PRIORITY' ] . "\" /><input type=\"submit\" name=\"input_doalphabetically\" value=\"" . $words_tickets[ 'ORDER_ALPHABETICALLY' ] . "\" /></form>" );
				
		$html -> maketablefooter();
		$html -> makeformsub( $words_tickets[ 'ADD_A_NEW_CATEGORY' ] );
		$websites = array();
		$query = $database -> dbquery( "SELECT preference_website, preference_value FROM " . DB_PREFIX . "esselbach_ct_preferences WHERE preference_key = 'WEBSITE_NAME'" );
		
		if( $database -> dbrows( $query ) )
		{
			echo "<strong>" . $words_tickets[ 'WEBSITE' ] . ":</strong> <select size=\"1\" name=\"input_category_website\">";
			echo "<option value=\"0\">" . $words_tickets[ 'ALL' ] . "</option>";
			
			while( list( $website_id, $website_name ) = $database -> dbrow( $query ) )
			{
				echo "<option value=\"" . $website_id . "\">" . $website_name . "</option>";
				$websites[ $website_id ] = $website_name;
			}
			
			echo "</select><br />";
		}
		
		$html -> makeeoption( $words_tickets[ 'CATEGORY_NAME' ], "input_category_name", "" );
		echo "<strong>" . $words_tickets[ 'PARENT_CATEGORY' ] . ":</strong><br /><select size=\"1\" name=\"input_category_parent\">";
		echo "<option value=\"0\">" . $words_tickets[ 'NONE' ] . "</option>";
		$query = $database -> dbquery( "SELECT ticketcat_id, ticketcat_website, ticketcat_name, ticketcat_parentid FROM " . DB_PREFIX . "esselbach_ct_ticketscats ORDER BY ticketcat_position, ticketcat_id" );
		
		while( list( $ticketcat_id, $ticketcat_website, $ticketcat_name, $ticketcat_parentid ) = $database -> dbrow( $query ) )
		{
			
			if( $ticketcat_parentid > 1 )
			{
				$ticketcat_name = str_repeat( "-", $ticketcat_parentid ) . " " . $ticketcat_name;
			}
			
			
			if( isset( $websites[ $ticketcat_website ] ) )
			{
				$ticketcat_website = " (" . $websites[ $ticketcat_website ] . ")";
			}
			else
			{
				$ticketcat_website = "";
			}
			
			echo "<option value=\"" . $ticketcat_id . "\">" . $ticketcat_name . $ticketcat_website . "</option>";
		}
		
		echo "</select>";
		echo "<br /><input type=\"hidden\" name=\"input_security_hash\" value=\"" . $security_hash . "\" /><input type=\"hidden\" name=\"aform\" value=\"doaddticketscategory\" /><input type=\"submit\" value=\"" . $words_tickets[ 'SUBMIT' ] . "\" />";
		$html -> makeformfooter();
	}
}
?>